#!/usr/bin/env python
# -*- coding: utf-8 -*-

from PyQt4.QtCore import QThread
from PyQt4.QtGui import QApplication
from engines import *
from players import *
from players.playerBase import Status
from defineEvent import *
#from mpris import playerBase
import dbus
from dbus.mainloop.glib import DBusGMainLoop
import gobject

class netThread(QThread):
	
	'''
	This class provide a network function for lrcShow-II, normally it connect to the search engine and analysis if the lrc we needed exists
	'''
	
	def __init__(self,receiver,artist,title,locale,proxy,engine,t=True):
		QThread.__init__(self)
		self.receiver=receiver
		self.artist=artist
		self.title=title
		self.locale=locale
		self.proxy=proxy
		self.engine=engine
		self.t=t
	
	def run(self):
		exec 'p=%s.%s(self.proxy,self.locale)' %(self.engine,self.engine)
		
		originalLrc,timeOut=p.request(self.artist,self.title)
			
		if(originalLrc is None):
			self.sleep(1)
			ev=netEvent(None,timeOut,p.netEncoder)
			QApplication.postEvent(self.receiver,ev)
		else:
			#print originalLrc[0][2]
			if(self.t):
				if(len(originalLrc)==1):
					originalLrc,timeOut=p.downIt(originalLrc[0][2])
					self.sleep(1)
					ev=netEvent(originalLrc,timeOut,p.netEncoder)
					QApplication.postEvent(self.receiver,ev)
				else:
					self.sleep(1)
					ev=userChooseEvent(originalLrc,self.engine)
					QApplication.postEvent(self.receiver,ev)
			else:
				ev=advancedUserChooseEvent(originalLrc,self.engine)
				QApplication.postEvent(self.receiver,ev)

class downAfterChoose(QThread):# modular engine design needed
	
	def __init__(self,receiver,url,proxy,engine,fromAdvDown=False):
		QThread.__init__(self)
		self.receiver=receiver
		self.url=url
		self.proxy=proxy
		self.engine=engine
		self.fromAdvDown=fromAdvDown
	
	def run(self):
		if(self.engine == None):
			p = engine.engine(self.proxy)
		else:
			exec 'p=%s.%s(self.proxy)' %(self.engine,self.engine)

		originalLrc,timeOut=p.downIt(self.url)
		ev=netEvent(originalLrc,timeOut,p.netEncoder,self.fromAdvDown)
		QApplication.postEvent(self.receiver,ev)
		

class myThread(QThread):
	
	'''
	This thread class provides the function to waiting for Amarok's signal, and when lrcShow-II first run, it would to decide the Amarok's status
	'''
	
	def __init__(self,receiver,player):
		QThread.__init__(self)
		#self.app=app
		self.receiver=receiver
		self.player=player
		
	def statusCallback(self,arg,startup = False):
		if startup:
			amarokSignal='startup'
		else:
			amarokSignal='engineStateChange'
		if arg == Status().Playing:
			amarokStatus='playing'
			self.sleep(1)#for a xine engine's bug
		elif arg == Status().Stopped:
			amarokStatus='stop'
		else:
			amarokStatus='pause'
		ev=myEvent(amarokSignal,amarokStatus)
		QApplication.postEvent(self.receiver,ev)
	
	def run(self):
		#DBusGMainLoop(set_as_default=True)
		if self.player != None:
			exec "self.handler = %s.%s()" % (self.player,self.player)
			self.handler.onStatusChange(self.statusCallback)
			self.statusCallback(self.handler.getStatus(),True)
			mainloop = gobject.MainLoop()
		else:
			raise RuntimeError("Player not supplied")
		#time.sleep(1)
		
