#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: hasNoRelationDialog.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@gmail.com
# Lisence: GPL-2.0

from PyQt4.QtCore import SIGNAL, SLOT
from PyQt4.QtGui import QDialog, QVBoxLayout, QHBoxLayout, QLabel, QComboBox, QPushButton, QFileDialog, QLineEdit
import sys,os

class hasNoRelationDialog(QDialog):
	
	def __init__(self, parent = None, *args):
        	QDialog.__init__(self, parent)
		self.setWindowTitle(_('Please set the lrc strategy'))
		self.setMinimumWidth(320)
		self.localLrc = args[0]
		MainWindowLayout=QVBoxLayout(None)
		layout1=QHBoxLayout(None)#
		layout1.setSpacing(50)
		layout1.setContentsMargins(5,5,5,5)
		self.label1=QLabel(self)
		self.label1.setText(_('Current track :'))
		self.trackLabel=QLabel(self)   #need to setText
		layout1.addWidget(self.label1)
		layout1.addWidget(self.trackLabel)
		
		layout11=QHBoxLayout(None)#
		layout11.setSpacing(50)
		layout11.setContentsMargins(5,5,5,5)
		self.label11=QLabel(self)
		self.label11.setText(_('Current tags :'))
		self.tagLabel=QLabel(self)   #need to setText
		layout11.addWidget(self.label11)
		layout11.addWidget(self.tagLabel)
		
		layout2=QHBoxLayout(None)
		layout2.setSpacing(50)
		layout2.setContentsMargins(5,5,5,5)
		self.label2=QLabel(self)
		self.label2.setText(_('Current strategy :'))
		self.comboBox=QComboBox(self)
		a=[_('No strategy'),_('Do not search local'),_('Do not search web'),_('Do not search at all'),_('Remember...')]
		for i in a:
			self.comboBox.insertItem(a.index(i),i)
		layout2.addWidget(self.label2)
		layout2.addWidget(self.comboBox)
		
		layout4=QHBoxLayout(None)
		layout4.setContentsMargins(10,10,10,10)
		self.pathLine=QLineEdit(self)
		self.pathLine.setReadOnly(True)
		self.pathLine.setEnabled(False)
		if(self.localLrc != None):
			self.pathLine.setText(self.localLrc)
		self.chooseButton=QPushButton(self)
		self.chooseButton.setText(_('Choose...'))
		self.chooseButton.setEnabled(False)
		layout4.addWidget(self.pathLine)
		layout4.addWidget(self.chooseButton)
		
		layout3=QHBoxLayout(None)#
		layout3.setSpacing(20)
		layout3.addStretch(0)
		layout3.setContentsMargins(10,10,10,10)
		self.okButton=QPushButton(self)
		self.okButton.setText(_('Ok'))
		self.okButton.setEnabled(False)
		self.cancelButton=QPushButton(self)
		self.cancelButton.setText(_('Cancel'))
		layout3.addWidget(self.okButton)
		layout3.addWidget(self.cancelButton)
		
		MainWindowLayout.addLayout(layout1)
		MainWindowLayout.addLayout(layout11)
		MainWindowLayout.addLayout(layout2)
		MainWindowLayout.addLayout(layout4)
		MainWindowLayout.addLayout(layout3)
		
		self.setLayout(MainWindowLayout)
		
		self.connect(self.comboBox,SIGNAL("activated(int)"),self.changeStatus)
		self.connect(self.okButton,SIGNAL("clicked()"),self,SLOT("accept()"))
		self.connect(self.cancelButton,SIGNAL("clicked()"),self,SLOT("reject()"))
		self.connect(self.chooseButton,SIGNAL("clicked()"),self.chooseLrc)
	
	def chooseLrc(self):
		if(self.localLrc != None):
			tmpDir = self.localLrc
		else:
			tmpDir = os.getenv('HOME')
		path=QFileDialog.getOpenFileName(self, _('Please choose a lrc file'), tmpDir, '*.lrc')
		if(path != u''):
			self.pathLine.setText(path)
			self.okButton.setEnabled(True)
		
	def changeStatus(self,f):
		if(f==0):
			self.okButton.setEnabled(False)
			self.pathLine.setEnabled(False)
			self.chooseButton.setEnabled(False)
		elif(f==4):
			if(self.pathLine.text().isEmpty()):
				self.okButton.setEnabled(False)
			else:
				self.okButton.setEnabled(True)
			self.pathLine.setEnabled(True)
			self.chooseButton.setEnabled(True)
		else:
			self.okButton.setEnabled(True)
			self.pathLine.setEnabled(False)
			self.chooseButton.setEnabled(False)