#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: lrcShow-X.py
# Develop CodeName: Shiningirl
# Version:  1.4.0
# Author: Xu Jia (sanfanling) and OutLikeAShoe
# Lisence: GPL-2.0
# Bug report: xujia19@gmail.com; https://bugs.launchpad.net/lrcshow-x

#lrcShow-X: General application of lrc for Audio players under linux
#Copyright (C) 2007 - 2010 Xu Jia <xujia19@gmail.com> &  OutLikeAShoe <outlikeashoe@gmail.com>

#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import os, sys, gettext, pickle
from commands import getoutput
import signal
import players
import ConfigParser


def initConfigFile():
	c='''[option]
lrcpath = %s,
savelrcpath = %s
download = no
linenumber = 3
backroundcolor = 59,86,115
fontcolor = 255,255,255
highlightcolor = 180,200,255
fontinfo = serif,9,-1,5,50,0,0,0,0,0
proxy = no
encoder = utf8
searchengine = ttPlayer
nolrc = normal
includecancel = no
autoinsert = no
titlebarinfo = no
completetag = no
filterlyrics = no
nullline = no
filterrule = http|lyrics|qq
filtercap = no
astrackname = no
minwidth = 360
savetomediapath = no
searchmediapath = no
useuslt = no
lastposition = 0,0
lrctagtype = lyrics3v2
lastshowmode = normal
lastistop = no
remembershowmode = no
trayicon = no
trayiconnotify = no
transparency = no
opacity = 10
rememberopacity = no
trayinfotime = 5000
multiengines = ttPlayer,
enablemultiengines = no
transeffect = no
autoembed = no
autoembedfromlocal = yes
autoembedfromnet = yes
editorsyncmode = no
linemargin = 12
recursiondepth = 0,
scrolltype = smooth

[shortcuts]
fullscreen = F
osd = O
normal = Esc
insert = F5
cancel = F6
editor = E
save = S
delay = -
advance = +
fastbar = I
refresh = R

[version]
pyqt = 4''' %(os.getenv('HOME'),os.getenv('HOME'))
	return c

def killHandler(signum, frame):
	try:
		os.remove('%s/.lrcShow-X/lrcShow-X.lock' %os.getenv('HOME'))
	except:
		pass
	sys.exit()

def checkLockfile(homePath):
	if(os.path.exists('%s/.lrcShow-X/lrcShow-X.lock' %homePath)):
		f = open('%s/.lrcShow-X/lrcShow-X.lock' %homePath)
		pid = f.read()
		f.close()
		output = getoutput('ps -C -p %s' %pid)
		if('lrcShow-X.py' in output):
			return False
		else:
			os.remove('%s/.lrcShow-X/lrcShow-X.lock' %homePath)
			return True
	else:
		return True

def creatLockfile(pid, homePath):
	f = open('%s/.lrcShow-X/lrcShow-X.lock' %homePath, 'w')
	f.write(pid)
	f.close()

def mainQt4(args):
	app=QApplication(sys.argv)
	win=mainBox(args)
	win.show()

	if(args != None):
		win.player = args
	else:
		try:
			win.player = players.autodetect()
		except Exception, e:
			sys.stdout.write(str(e)+'\n')
			try:
				os.remove('%s/.lrcShow-X/lrcShow-X.lock' %self.homePath)
			except:
				pass
			sys.exit()

	playerControl = getattr(players,win.player)
	playerControl = getattr(playerControl,win.player)
	try:
		win.di = playerControl()
	except OverflowError, e:
		sys.stdout.write(str(e)+'\n')
		if(win.player=='amarok'):
			sys.stdout('Error: Amarok2 is not running; or this application does not support Amarok-1.x, you could use lrcShow-II script instead\n')
			try:
				os.remove('%s/.lrcShow-X/lrcShow-X.lock' %self.homePath)
			except:
				pass
			sys.exit()
		else:
			sys.stdout.write('Error: %s is not running\n' %win.player.title())
			try:
				os.remove('%s/.lrcShow-X/lrcShow-X.lock' %self.homePath)
			except:
				pass
			sys.exit()
		
	thread=myThread(win,win.player)
	thread.start()

	sys.exit(app.exec_())

if(__name__=="__main__"):
	os.chdir(os.path.join(os.getcwd(), os.path.dirname(sys.argv[0])))
	signal.signal(signal.SIGINT,killHandler)
	
	try:
		gettext.translation('lrcShow-X','locale').install(unicode=True)
	except IOError:
		gettext.translation('lrcShow-X','locale',languages=['en_US']).install(unicode=True)
	
	homePath=os.getenv('HOME')
	
	if(not os.path.isdir('%s/.lrcShow-X' %homePath)):
		os.mkdir('%s/.lrcShow-X' %homePath)
	
	if(not os.path.exists('%s/.lrcShow-X/lrcShow-X.db' %homePath)):
		mydb=open('%s/.lrcShow-X/lrcShow-X.db' %homePath,'w')
		pickler=pickle.Pickler(mydb,True)
		pickler.dump({})
		mydb.close()
	
	if(not os.path.exists('%s/.lrcShow-X/lrcShow-X.conf' %homePath)):
		config=initConfigFile()
		file=open('%s/.lrcShow-X/lrcShow-X.conf' %homePath,'w')
		file.write(config)
		file.close()
	
	supportedPlayer=players.supportedPlayers
	usage = 'Usage: lrcShow-X [--help] [%s]' % ("] [".join(["--%s" % i for i in supportedPlayer]))
	if len(sys.argv)>2:
		sys.stdout.write(usage+'\n')
		sys.exit()
	elif len(sys.argv) == 2:
		if(sys.argv[1]=='--help' or sys.argv[1][:2]!='--'):
			sys.stdout.write(usage+'\n')
			sys.exit()
		else:
			argv=sys.argv[1].replace('-','')
			if(argv not in supportedPlayer):
				sys.stdout.write('Error: %s is not supported at present\n' %argv.title())
				sys.exit()
	else:
		argv = None
		
	lock = checkLockfile(homePath)
	if(lock):
		creatLockfile(str(os.getpid()), homePath)
	else:
		sys.stdout.write('Error: lrcShow-X allows only one instance\n')
		sys.exit()


	try:
		from PyQt4.QtCore import *
		from PyQt4.QtGui import QApplication
	except:
		sys.stdout.write('lrcShow-X: Please install PyQt4 (Python and Qt4 bindings) first!\n')
		try:
			os.remove('%s/.lrcShow-X/lrcShow-X.lock' %homePath)
		except:
			pass
		sys.exit()
	else:
		from mainGuiQt4 import mainBox
		from defineThread import myThread
	
	mainQt4(argv)

