#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: mainGuiQt4.py
# Author: Xu Jia (Sanfanling), OutLikeAShoe
# Lisence: GPL-2.0

import chardet
import embedLrc
from PyQt4.QtGui import *
from PyQt4.QtCore import *
import lrcParser,readConfig,s2t
from chooseItemQt4 import chooseItem
from lrcEditorQt4 import lrcEditorQt4
from helpBrowserQt4 import helpWindow
from ttpChooseGuiQt4 import ttpChooseGui
from otherSettingQt4 import otherSettingQt4
from hasRelationDialogQt4 import hasRelationDialog
from hasNoRelationDialogQt4 import hasNoRelationDialog
from advancedSearchNet import advancedSearchNet
from chooseEngine import chooseEngine
import sys,glob,re,os,random,pickle
from urllib import unquote_plus
from defineThread import *
import ConfigParser
from baseGuiQt4 import baseGuiQt4


############   main GUI process     ###########

class mainBox(baseGuiQt4):
	
	def __init__(self, *args):

        	baseGuiQt4.__init__(self, None)
		#self.setObjectName('mainBox')
		self.winFlags=self.windowFlags()
		self.showMode='normal'
		self.homePath=os.getenv('HOME')

		p=readConfig.readConfig()
		try:# app is developing, the newest config file would be changed, if config file is changed and user's is still old, an error would occur, then need to update
			(tmpPath, self.ifDownload, self.lineNum, bc, fc, hc, fontInfo, self.proxy, self.encoderToWrite, self.searchEngine, self.saveLrcPath, self.noLrc, self.includeCancel, self.autoInsertAmarok, self.titleBarInfo, self.completeTag, self.filterLyrics, self.nullLine, self.filterRule, self.filterCap, self.asTrackName, self.minWidth, self.saveToMediaPath, self.searchMediaPath, self.useUslt, lastPos, self.lrcTagType, self.lastShowMode, self.lastIsTop, self.rememberShowMode, self.enableTrayIcon, self.trayIconNotify, self.transparency, opacity, self.rememberOpacity, self.trayInfoTime, self.enableMultiEngines, tmpMultiEngines, self.transEffect, self.autoEmbed, self.autoEmbedFromLocal, self.autoEmbedFromNet, self.editorSyncMode, self.lineMargin, tmpRecursionDepth, self.scrollType, fullscreen, osd, normal, insert, cancel, editor, save, delay, advance, fastbar, refresh) = p.parse()

		except:
			QMessageBox.information(self,_('Config file error'),_('Maybe the config file is out-of-date\nlrcShow-X will try to update it for you and keep the old settings\nPlease re-start lrcShow-X\nIf this dialog appears again, please delete the config file'))
			import updateConfig
			p=updateConfig.updateConfig('4')
			p.update()
			try:
				os.remove('%s/.lrcShow-X/lrcShow-X.lock' %self.homePath)
			except:
				pass
			sys.exit()

		self.shortCut_fullscreen=QKeySequence.fromString(fullscreen)
		self.shortCut_osd=QKeySequence.fromString(osd)
		self.shortCut_normal=QKeySequence.fromString(normal)
		self.shortCut_insert=QKeySequence.fromString(insert)
		self.shortCut_cancel=QKeySequence.fromString(cancel)
		self.shortCut_editor=QKeySequence.fromString(editor)
		self.shortCut_save=QKeySequence.fromString(save)
		self.shortCut_delay=QKeySequence.fromString(delay)
		self.shortCut_advance=QKeySequence.fromString(advance)
		self.shortCut_fastbar=QKeySequence.fromString(fastbar)
		self.shortCut_refresh=QKeySequence.fromString(refresh)
		
		
		
		if(self.rememberOpacity=='yes' and self.transparency=='yes'):
			self.opacity=opacity
		else:
			self.opacity=10
		self.setWindowOpacity(self.opacity/10.0)
		
		if(self.proxy=='no'):
			self.proxy=None
		else:
			self.proxy={'http':self.proxy}
		self.initMenu()
		
		self.iconTray=QSystemTrayIcon(QIcon('./icon/logo.png'),self)
		self.iconTray.setToolTip('lrcShow-X')
		self.iconTray.setContextMenu(self.myMenu)
		if(self.enableTrayIcon=='yes'):
			self.iconTray.setVisible(True)
		
		if(self.ifDownload=='yes'):
			self.downloadMenu_yesAction.setChecked(True)
		else:
			self.downloadMenu_noAction.setChecked(True)
		self.downloadMenu_thisAction.setEnabled(False)
		self.initSettingMenuBar()
		a=bc.split(',')
		b=fc.split(',')
		c=hc.split(',')
		self.backGroundColor=QColor(int(a[0]),int(a[1]),int(a[2]))
		self.foreGroundColor=QColor(int(b[0]),int(b[1]),int(b[2]))
		self.highLightColor=QColor(int(c[0]),int(c[1]),int(c[2]))
		if(QT_VERSION_STR < '4.5.0'):
			self.displayMenu_transparencyAction.setEnabled(False)
		#if(self.transEffect == 'yes'):
			#self.setAttribute(Qt.WA_TranslucentBackground, True)
			#self.setAttribute(Qt.WA_NoSystemBackground, True)
			#self.displayMenu_transparencyAction.setChecked(True)
			
		
		#self.setAttribute(Qt.WA_TranslucentBackground, True)
		self.setAutoFillBackground(True)# Q: is it necessary? tell me!
		self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
		self.setMinimumHeight(200)
		self.setMinimumWidth(self.minWidth)
		px,py=lastPos.split(',')
		self.move(int(px),int(py))
		self.currentFont=QFont()
		self.currentFont.fromString(fontInfo)
		self.setFont(self.currentFont)
		self.margin=QFontMetrics(self.font()).height()+self.lineMargin
		self.setFixedHeight(self.margin*self.lineNum)

		self.setWindowIcon(QIcon('./icon/logo.png'))
		self.myTimer = QTimeLine()
		#self.myTimer.setUpdateInterval(40)
		self.myTimer.setCurveShape(QTimeLine.LinearCurve)
		#self.myTimer.setSingleShot(True)
		self.checktimer=QTimer()
		self.checktimer.setSingleShot(False)
		self.hideMouseTimer=QTimer()# for auto hiding cursor in fullscreen display mode
		self.locale=sys.getfilesystemencoding()# detecting locale
		self.multiEngines=tmpMultiEngines.split(',')[0:-1]
		self.path=tmpPath.split(',')
		self.path=map(lambda x:unicode(x,'utf8').encode(self.locale),self.path)[0:-1]
		self.recursionDepth = tmpRecursionDepth.split(',')[0:-1]
		self.saveLrcPath=unicode(self.saveLrcPath,'utf8').encode(self.locale)
		mydb=open('%s/.lrcShow-X/lrcShow-X.db' %self.homePath,'r')# get the strategy data from the database
		u=pickle.Unpickler(mydb)
		self.myData=u.load()
		mydb.close()
		
		self.configFile = ConfigParser.ConfigParser()
		self.configFile.read('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath)
		
		self.encoder=self.encoderToWrite
		self.fileName=None
		self.originalLrc=None
		self.extPath=None
		self.usltLrc=None
		self.totalSeekTime = 0

		#self.animateTimer = QTimeLine()
		#self.animateTimer.setCurveShape(QTimeLine.LinearCurve)
		
		self.topIsChecked=False
		if(self.rememberShowMode=='yes'):
			if(self.lastShowMode=='osd'):
				self.displayMenu_osdAction_()
			#elif(self.lastShowMode=='fullscreen'):
				#self.displayMenu_fullscreenAction_()
			if(self.lastIsTop=='yes'):
				self.displayMenu_topAction.setChecked(True)
				self.displayMenu_topAction_(True)
		
		if(self.scrollType == 'jump'):
			self.effectMenu_jumpAction.setChecked(True)
		elif(self.scrollType == 'always'):
			self.effectMenu_alwaysRollAction.setChecked(True)
		else:
			self.effectMenu_rollAction.setChecked(True)


		self.connect(self.myTimer, SIGNAL("finished()"), self.nextDuration)
		self.connect(self.myTimer, SIGNAL("valueChanged(qreal)"), self.animateEffect_scroll)
		self.connect(self.hideMouseTimer,SIGNAL("timeout()"),self.checkHideMouse)
		self.connect(self.checktimer,SIGNAL("timeout()"),self.checkTime)
		self.connect(self.lrcAdjustMenu_delayAction,SIGNAL("triggered()"),self.seekSlow)
		self.connect(self.lrcAdjustMenu_advancedAction,SIGNAL("triggered()"),self.seekFast)
		self.connect(self.lrcAdjustMenu_saveToFileAction,SIGNAL("triggered()"),self.saveToFile)
		self.connect(self.amarokControlMenu_playorpauseAction,SIGNAL("triggered()"),self.amarokControlMenu_playorpause)
		self.connect(self.amarokControlMenu_stopAction,SIGNAL("triggered()"),self.amarokControlMenu_stop)
		self.connect(self.amarokControlMenu_prevAction,SIGNAL("triggered()"),self.amarokControlMenu_prev)
		self.connect(self.amarokControlMenu_nextAction,SIGNAL("triggered()"),self.amarokControlMenu_next)
		self.connect(self.colorMenu_backAction,SIGNAL("triggered()"),self.colorMenu_back)
		self.connect(self.colorMenu_foreAction,SIGNAL("triggered()"),self.colorMenu_fore)
		self.connect(self.colorMenu_lightAction,SIGNAL("triggered()"),self.colorMenu_light)
		self.connect(self.colorMenu_defaultAction,SIGNAL("triggered()"),self.colorMenu_default)
		self.connect(self.setFontAction,SIGNAL("triggered()"),self.setFontAction_)
		self.connect(self.setLineAction,SIGNAL("triggered()"),self.setLineAction_)
		self.connect(self.downloadMenu_yesAction,SIGNAL("triggered()"),self.downloadMenu_yesAction_)
		self.connect(self.downloadMenu_noAction,SIGNAL("triggered()"),self.downloadMenu_noAction_)
		self.connect(self.downloadMenu_thisAction,SIGNAL("triggered()"),self.downloadMenu_thisAction_)
		self.connect(self.effectMenu_jumpAction, SIGNAL("triggered()"), self.switchEffect_jump)
		self.connect(self.effectMenu_rollAction, SIGNAL("triggered()"), self.switchEffect_roll)
		self.connect(self.effectMenu_alwaysRollAction, SIGNAL("triggered()"), self.switchEffect_alwaysRoll)
		self.connect(self.displayMenu_normalAction,SIGNAL("triggered()"),self.displayMenu_normalAction_)
		self.connect(self.displayMenu_fullscreenAction,SIGNAL("triggered()"),self.displayMenu_fullscreenAction_)
		self.connect(self.displayMenu_osdAction,SIGNAL("triggered()"),self.displayMenu_osdAction_)
		self.connect(self.displayMenu_topAction,SIGNAL("triggered(bool)"),self.displayMenu_topAction_)
		self.connect(self.displayMenu_transparencyAction,SIGNAL("triggered(bool)"),self.displayMenu_transparencyAction_)
		self.connect(self.openLrcEditorAction,SIGNAL("triggered()"),self.openLrcEditorAction_)
		self.connect(self.setSearchEngineAction,SIGNAL("triggered()"),self.setSearchEngineAction_)
		self.connect(self.otherFunctionsMenu_searchAction,SIGNAL("triggered()"),self.otherFunctionsMenu_searchAction_)
		self.connect(self.otherFunctionsMenu_searchAdvancedAction,SIGNAL("triggered()"),self.otherFunctionsMenu_searchAdvancedAction_)
		self.connect(self.otherFunctionsMenu_reloadAction,SIGNAL("triggered()"),self.otherFunctionsMenu_reloadAction_)
		self.connect(self.otherFunctionsMenu_cancelAction,SIGNAL("triggered()"),self.otherFunctionsMenu_cancelAction_)
		#self.connect(self.otherFunctionsMenu_insertAction,SIGNAL("triggered()"),self.otherFunctionsMenu_insertAction_)
		self.connect(self.otherFunctionsMenu_otherSetting,SIGNAL("triggered()"),self.otherFunctionsMenu_otherSetting_)
		self.connect(self.otherFunctionsMenu_readUsltAction,SIGNAL("triggered()"),self.otherFunctionsMenu_readUsltAction_)
		self.connect(self.otherFunctionsMenu_insertUsltAction,SIGNAL("triggered()"),self.otherFunctionsMenu_insertUsltAction_)
		self.connect(self.otherFunctionsMenu_deleteUsltAction,SIGNAL("triggered()"),self.otherFunctionsMenu_deleteUsltAction_)
		self.connect(self.otherFunctionsMenu_deleteAllUsltAction,SIGNAL("triggered()"),self.otherFunctionsMenu_deleteAllUsltAction_)
		self.connect(self.setStrategyAction,SIGNAL("triggered()"),self.setStrategyAction_)
		self.connect(self.viewHelpAction,SIGNAL("triggered()"),self.viewHelpAction_)
		self.connect(self.aboutAction,SIGNAL("triggered()"),self.aboutAction_)
		self.connect(self.aboutQtAction,SIGNAL("triggered()"),self.aboutQtAction_)
		self.connect(self.closeAction,SIGNAL("triggered()"),self.quitWidnow)
		self.connect(self.iconTray,SIGNAL("activated(QSystemTrayIcon::ActivationReason)"),self.iconTrayAction)
		
		self.connect(self.quitShortcut,SIGNAL("activated()"),self.quitWidnow)
		self.connect(self.nextTrackShortcut,SIGNAL("activated()"),self.amarokControlMenu_next)
		self.connect(self.prevTrackShortcut,SIGNAL("activated()"),self.amarokControlMenu_prev)
		self.connect(self.pauseTrackShortcut,SIGNAL("activated()"),self.amarokControlMenu_playorpause)
		self.connect(self.stopTrackShortcut,SIGNAL("activated()"),self.amarokControlMenu_stop)
		#self.connect(self.animateTimer,SIGNAL("frameChanged(int)"),self.animateEffect_scroll)
		#self.connect(self.animateTimer,SIGNAL("finished()"),self.highLight)
	
	def iconTrayAction(self,reason):
		if(reason==QSystemTrayIcon.Trigger):
			if(self.isHidden()):
				self.show()
			else:
				self.hide()
	
	def customEvent(self,ev):
		if(ev.type()==QEvent.User+1): # for detecting Amarok's status when app starts up and listening the signal from Amarok
			self.amarokSignal=ev.amarokSignal 
			self.amarokStatus=ev.amarokStatus
			self.myTimer.stop()
			if(self.checktimer.isActive()):
				self.checktimer.stop()
			try:
				if self.downAfterChoose.isRunning():
					self.downAfterChoose.terminate()
			except:
				pass
			try:
				if self.downloadThread.isRunning():
					self.downloadThread.terminate()
			except:
				pass
			try:# if some dialogs exist when changes the track, they need to be shut down, the same as below, for example, the strategy dialog has the information just belongs to current track, it shouldn't be shown when different track starts
				self.chooseItermDialog1.done(-1)
			except:
				pass
			try:
				self.chooseItermDialog2.done(-1)
			except:
				pass
			#try:
				#self.advanceSearchBox.done(-1)
			#except:
				#pass
			try:
				self.relationDialog.done(-1)
			except:
				pass
			try:
				self.playerStatusSyncToEditor()
			except:
				pass
			
			if(self.amarokStatus=='playing'):
				self.initTime()
				self.checktimer.setInterval(2500)
				self.checktimer.start()
			else:
				self.checktimer.stop()
				self.initTime()
			
			if(self.amarokStatus=='pause' and self.amarokSignal=='engineStateChange'):# pause
				if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
					self.iconTray.showMessage('lrcShow-X', _('Paused'),1,self.trayInfoTime)
					self.amarokControlMenu_playorpauseAction.setText(_('Play'))
				self.amarokControlMenu_playorpauseAction.setIcon(QIcon('./icon/amarok_play.png'))
			if(self.amarokStatus=='playing' or (self.amarokStatus=='pause' and self.amarokSignal=='startup')):
				try:
					self.title=self.di.getTitle()
					self.title=self.title.encode(self.locale)
				except:
					sys.stdout.write(self.title+'\n')
					self.title=''
				try:
					self.artist=self.di.getArtist()
					self.artist=self.artist.encode(self.locale)
				except:
					sys.stdout.write(self.artist+'\n')
					self.artist=''
				self.media=unquote_plus(self.di.getMediaFile().replace('file://','').encode(self.locale))
				self.extInfo=os.path.splitext(os.path.basename(self.media))[0]
				self.extPath=os.path.dirname(self.media)
				
				if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
					self.iconTray.showMessage('lrcShow-X',_('Now playing :  ')+unicode('%s - %s' %(self.artist,self.title),self.locale),1,self.trayInfoTime)
				
				if(self.asTrackName=='yes'):
					self.nameForSave=self.extInfo+'.lrc'
				else:
					self.nameForSave = ('%s - %s.lrc' %(self.artist,self.title)).translate(None, '<>/\\|:"*?')
				self.fileName=None
				self.originalLrc=None
				self.usltLrc=None
				self.downloadMenu_thisAction.setEnabled(False)
				
				
				if(self.titleBarInfo=='yes' and (self.artist != '' or self.title != '')):
					self.setWindowTitle('%s - %s' %(unicode(self.artist,self.locale),unicode(self.title,self.locale)))
				else:
					self.setWindowTitle('lrcShow-X')
				if(self.amarokStatus=='pause' and self.amarokSignal=='startup'): #pause
					self.amarokControlMenu_playorpauseAction.setText(_('Play'))
					self.amarokControlMenu_playorpauseAction.setIcon(QIcon('./icon/amarok_play.png'))
				else:
					self.amarokControlMenu_playorpauseAction.setText(_('Pause'))
					self.amarokControlMenu_playorpauseAction.setIcon(QIcon('./icon/amarok_pause.png'))
				self.amarokControlMenu_stopAction.setEnabled(True)
				self.otherFunctionsMenu_searchAction.setEnabled(True)
				self.otherFunctionsMenu_searchAdvancedAction.setEnabled(True)
				self.setStrategyAction.setEnabled(True)
				self.otherFunctionsMenu_reloadAction.setEnabled(True)
				self.otherFunctionsMenu_readUsltAction.setEnabled(True)
				self.otherFunctionsMenu_deleteUsltAction.setEnabled(True)
				self.otherFunctionsMenu_deleteAllUsltAction.setEnabled(True)
				
				if(self.title=='' and self.artist==''):
					self.checkData(True)
				else:
					if(self.completeTag=='no'):
						self.checkData()
					else:
						if(self.title != '' and self.artist != ''):
							self.checkData()
						else:
							self.checkData(True)
			if(self.amarokStatus=='stop'):
				if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
					self.iconTray.showMessage('lrcShow-X', _('Stopped'),1,self.trayInfoTime)
					
				self.fileName=None
				self.originalLrc=None
				self.usltLrc=None
				self.extPath=None
				if(self.titleBarInfo=='yes'):
					self.setWindowTitle('lrcShow-X')
				else:
					self.setWindowTitle('lrcShow-X')
				self.amarokControlMenu_playorpauseAction.setText(_('Play'))
				self.amarokControlMenu_playorpauseAction.setIcon(QIcon('./icon/amarok_play.png'))
				self.amarokControlMenu_stopAction.setEnabled(False)
				self.otherFunctionsMenu_searchAction.setEnabled(False)
				self.otherFunctionsMenu_searchAdvancedAction.setEnabled(False)
				self.setStrategyAction.setEnabled(False)
				self.otherFunctionsMenu_reloadAction.setEnabled(False)
				self.otherFunctionsMenu_readUsltAction.setEnabled(False)
				self.otherFunctionsMenu_deleteUsltAction.setEnabled(False)
				self.otherFunctionsMenu_deleteAllUsltAction.setEnabled(False)
				
				self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>',True)
					
		elif(ev.type()==QEvent.User+2):# for receiving the lrc from net
			self.originalLrc=ev.originalLrc
			t=ev.timeOut
			r=ev.fromAdvDown
			if(self.originalLrc and not ev.netEncoder):
				self.netEncoder=chardet.detect(self.originalLrc)['encoding']
				if(self.netEncoder=='GB2312'):
					self.netEncoder='gb18030'
			else:
				self.netEncoder=ev.netEncoder
			if(self.originalLrc):
				self.initEvent(self.originalLrc,True,r)
			else:
				if(not t):
					self.showInfo('<p align="center">'+_('Nothing has been searched')+'</p>')
				else:
					self.showInfo('<p align="center">'+_('Connection timeout')+'</p>')
					
		if(ev.type()==QEvent.User+3):# when searched more than one lrc from net, especially use the ttplayer engine
			lrcList=ev.alist
			engineReturn=ev.engine
			self.chooseItermDialog1=ttpChooseGui(self)
			for j in lrcList:
				self.chooseItermDialog1.listBox.insertItem(lrcList.index(j),j[0].decode('utf8')+' - '+j[1].decode('utf8'))
			self.chooseItermDialog1.listBox.setCurrentRow(0)
			result1=self.chooseItermDialog1.exec_()
			if(result1==QDialog.Accepted):
				k=self.chooseItermDialog1.listBox.currentRow()
				url=lrcList[k][2]
				self.downAfterChoose=downAfterChoose(self,url,self.proxy,engineReturn)
				self.downAfterChoose.start()
			elif(result1==QDialog.Rejected):
				self.showInfo('<p align="center">'+_('Nothing has been searched')+'</p>')

	def showInfo(self,lf,windowBehavior=False):# to show the necessary info in window, no lrc, Amarok stops, searching and so on
	 	'''
		lf: it should be the information that shows on window
		windowBehavior: if set ture, meas the window wouldn't be under the window behavior settings
		'''
		self.mainContents=lf
		self.myTimer.stop()
		self.initMainEvent(True)
		self.otherFunctionsMenu_cancelAction.setEnabled(False)
		#self.otherFunctionsMenu_insertAction.setEnabled(False)
		self.lrcAdjustMenu_delayAction.setEnabled(False)
		self.lrcAdjustMenu_advancedAction.setEnabled(False)
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		self.otherFunctionsMenu_insertUsltAction.setEnabled(False)
		
		if(not windowBehavior):
			if(self.noLrc=='normal'):
				pass
			elif(self.noLrc=='hide'):
				self.hide()
			elif(self.noLrc=='mini'):
				self.showMinimized()
		
		if(self.editorSyncMode == 'yes'):
			try:
				self.dataSyncToEditor()
			except:
				pass
	
	def initEvent(self,lf,lrcFromNet=False,fromAdvDown=False, canAutoEmbed = False): # new lrc found, necessary init process
		'''
		lf: lrc file's contents
		lrcFromNet: if true, means this lrc is from internet, otherwise means from local or media file
		fromAdvDown: if this method is called by advanced search interface, please choose ture
		canAutoEmbed: control if the initEvent function could execute auto embed lrc function
		'''
		
		if(self.noLrc=='hide' and self.isHidden()):
			if(self.showMode=='fullscreen'):
				self.show()
				self.showFullScreen()
			else:
				self.show()
		if(self.noLrc=='mini' and self.isMinimized()):
			if(self.showMode=='fullscreen'):
				self.showFullScreen()
			else:
				self.showNormal()
		self.totalSeekTime=0
		self.otherFunctionsMenu_cancelAction.setEnabled(True)
		#self.otherFunctionsMenu_insertAction.setEnabled(True)
		self.lrcAdjustMenu_delayAction.setEnabled(True)
		self.lrcAdjustMenu_advancedAction.setEnabled(True)
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		self.otherFunctionsMenu_insertUsltAction.setEnabled(True)
		
		self.openLrcEditorAction.setEnabled(True)
		if((self.ifDownload=='yes' and lrcFromNet) or (fromAdvDown and lrcFromNet)):
			try:
				unicode(lf,self.netEncoder).encode(self.encoderToWrite)
			except UnicodeEncodeError:
				QMessageBox.critical(self,_('Encode error'),_('An error occurs when encode the fetched lrc (%s) to saving encode (%s), ignore the download!\nNormally because the fetched lrc file has some characters that can not be encoded.\nIf this dialog shows frequancy, strongly recommend to turn off auto download, otherwise, you could set the encoding for saving to gb18030 or utf8 to avoid this problem.') %(self.netEncoder,self.encoderToWrite))
			else:
				if(self.saveToMediaPath=='yes' and self.extPath):
					pathTmp=self.extPath
				else:
					pathTmp=self.saveLrcPath
				if(os.path.exists(os.path.join(pathTmp,self.nameForSave))):
					a=QMessageBox.question(self,_('Ask'),_('A same name file exists, are you sure to overwrite?'),QMessageBox.Yes,QMessageBox.No)
					if(a==QMessageBox.Yes):
						try:
							file=open(os.path.join(pathTmp,self.nameForSave),'w')
						except:
							self.iconTray.showMessage('lrcShow-X',_('Fail in download lrc, please check the permission!'),1,self.trayInfoTime)
						else:
							self.saveToLocal(file, lf, pathTmp)
							if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
								self.iconTray.showMessage('lrcShow-X', _('Lrc saved : ')+unicode(self.nameForSave,self.locale), 1, self.trayInfoTime)
				else:
					try:
						file=open(os.path.join(pathTmp,self.nameForSave),'w')
					except:
						self.iconTray.showMessage('lrcShow-X', _('Fail in download lrc, please check the permission!'),1,self.trayInfoTime)
					else:
						self.saveToLocal(file, lf, pathTmp)
						if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
							self.iconTray.showMessage('lrcShow-X', _('Lrc saved : ')+unicode(self.nameForSave,self.locale), 1, self.trayInfoTime)

		if(self.ifDownload=='no' and lrcFromNet):
			self.downloadMenu_thisAction.setEnabled(True)
		if(lrcFromNet):
			a=unicode(lf,str(self.netEncoder),'ignore')
			p=lrcParser.lrc(a)
			if(self.lineNum==1):
				self.tag,self.mainContents=p.format(self.lineMargin, self.filterRule, self.filterLyrics, self.nullLine, self.filterCap, True)
			else:
				self.tag,self.mainContents=p.format(self.lineMargin, self.filterRule, self.filterLyrics, self.nullLine, self.filterCap)
			self.initMainEvent()
			self.goToCurrentPara()
		else:
			self.encoder=chardet.detect(lf)['encoding']
			if(self.encoder=='GB2312'):
				self.encoder='gb18030'
			elif self.encoder == None:
				self.encoder = "utf-8"
			try:
				a=unicode(lf,self.encoder)
			except UnicodeDecodeError:
				self.showInfo('<p align="center">'+_('An encode error ocurrs when reading local lrc file')+'</p>')
				self.openLrcEditorAction.setEnabled(False)
			else:
				p=lrcParser.lrc(a)
				if(self.lineNum==1):
					self.tag,self.mainContents=p.format(self.lineMargin, self.filterRule, self.filterLyrics, self.nullLine, self.filterCap, True)
				else:
					self.tag,self.mainContents=p.format(self.lineMargin, self.filterRule, self.filterLyrics, self.nullLine, self.filterCap)
				self.initMainEvent()
				self.goToCurrentPara()
		if(canAutoEmbed and self.autoEmbed == 'yes'):
			self.otherFunctionsMenu_insertUsltAction_(True)
		
		if(self.editorSyncMode == 'yes'):
			try:
				self.dataSyncToEditor()
			except:
				pass
	
	def saveToLocal(self, f, lf, pathTmp):
		f.write(unicode(lf,self.netEncoder).encode(self.encoderToWrite))
		f.close()
		self.originalLrc=None
		self.fileName=os.path.join(pathTmp,self.nameForSave)
	
	def initMainEvent(self,noLrcInfo=False):
		'''
		noLrcInfo: if the window has no lrc and just show information, please set true
		'''
		if(self.lineNum==1):
			if(self.showMode != 'osd'):
				self.displayMenu_osdAction_()
			self.displayMenu_normalAction.setEnabled(False)
			if(self.scrollType != 'always'):
				self.scrollType = 'always'
				self.effectMenu_alwaysRollAction.setChecked(True)
			self.effectMenu_rollAction.setEnabled(False)
			self.effectMenu_jumpAction.setEnabled(False)
		if(self.lineNum==1 and not noLrcInfo):

			fontInfoClass=QFontMetrics(self.font())
			spacelength=fontInfoClass.width(u' ')

			spaceNum=(self.width()/2)/spacelength
			
			t=self.mainContents.strip().split(u'!@#$')
			self.fragmentLength=map(lambda x:fontInfoClass.width(x),t)
			t=map(lambda x: u'&nbsp;&nbsp;&nbsp;&nbsp;%s&nbsp;&nbsp;&nbsp;&nbsp;' %x,t[1:])
			lrcFile=u'&nbsp;'*spaceNum
			for jj in t:
				lrcFile+=jj
			lrcFile=lrcFile+u'&nbsp;'*spaceNum
			self.setHtml(lrcFile)
			self.fixLength=8*spacelength
				
		else:
			j='<p align="center">&nbsp;</p>'*((self.lineNum-1)/2)
			lrcFile=j+self.mainContents+j+'<p align="center">&nbsp;</p>'
			self.setText(lrcFile)
	
	def goToCurrentPara(self):# to center and highlight the current lineMargin
		self.moveCursor(QTextCursor.Start)
		self.hPos = 0
		self.scrollDistance = 0
		currentTime=int(self.di.getTimePoint())+self.totalSeekTime
		try:
			p=-1
			while True:
				p+=1
				if(self.tag[p]>=currentTime):
					break
		except AttributeError:
			pass
		except:
			if(self.lineNum==1):
				all=0
				for i in range(len(self.tag)):
					all+=self.fragmentLength[i]
				self.hPos=len(self.tag)*self.fixLength+all+self.fragmentLength[len(self.tag)]
				self.horizontalScrollBar().setValue(self.hPos)
			else:
				for i in range(len(self.tag)+(self.lineNum-1)/2-1):
					self.moveCursor(QTextCursor.Down)
				self.highLight()
				self.hPos=self.margin*(len(self.tag)-1)
				self.verticalScrollBar().setValue(self.hPos)
			
		else:
			if(self.lineNum==1):
				all=0
				for i in range(p):
					all+=self.fragmentLength[i]
				self.hPos=p*self.fixLength+all+self.fragmentLength[p]
				self.horizontalScrollBar().setValue(self.hPos)
				self.num=p
				if(self.amarokStatus=='pause'):
					pass
				else:
					self.next_time = self.tag[p]-currentTime
					self.myTimer.setDuration(self.next_time)
					self.myTimer.start()
				
			else:
				for i in range(p+(self.lineNum-1)/2-1):
					self.moveCursor(QTextCursor.Down)
				self.num=p
				if(self.amarokStatus=='pause'):
					pass
				else:
					self.next_time = self.tag[p]-currentTime
					self.myTimer.setDuration(self.next_time)
					self.myTimer.start()
				try:
					self.highLight()
					self.hPos=self.margin*(self.num-1)
					self.verticalScrollBar().setValue(self.hPos)
				except:
					pass

	def downLoad(self, fastSearch=False):
		'''
		fastSearch: downLoad method is called when the application need to search the lrc from net, whatever from fast search or advanced search. If this method is called by advanced search, not by multi-search, please set true
		'''
		try:
			if(self.downloadThread.isRunning()):
				self.downloadThread.terminate()
		except:
			pass
		if(self.enableMultiEngines == 'yes' and not fastSearch):
			txt = _('Searching the lrc with multi-search mode...')
			self.showInfo('<p align="center">'+txt+'</p>',True)
			self.advanceSearchBox=advancedSearchNet(self,self.searchEngine,self.artist,self.title,self.locale,self.proxy,self.multiEngines)
			self.advanceSearchBox.searchAction()
			self.connect(self.advanceSearchBox.testButton,SIGNAL("clicked()"),self.advDownLrc)
			result=self.advanceSearchBox.exec_()
			if(result==QDialog.Accepted):
				if(self.advanceSearchBox.download.isChecked()):
					self.advDownLrc(True)
					self.downloadMenu_thisAction.setEnabled(False)
				else:
					self.advDownLrc()
			else:
				self.showInfo('<p align="center">'+_('Nothing has been searched')+'</p>')
		else:
			txt=_('Searching the lrc on ')+self.searchEngine+_(' lyrics server...')
			self.showInfo('<p align="center">'+txt+'</p>',True)
			self.downloadThread=netThread(self,self.artist,self.title,self.locale,self.proxy,self.searchEngine)
			self.downloadThread.start()
	
	def checkData(self, noTagInfo = False):# special function to check if the current track has strategy or embed lrc
		if(self.useUslt=='yes' and self.media != ''):
			p=embedLrc.embedLrc(self.media)
			lrc=p.detectLrc()
			if(lrc != None):
				self.usltLrc=lrc
				self.initEvent(lrc, False, False, False)
				return
		data=self.myData.get(os.path.basename(self.media),False)
		if(data != 'FLAG.SKIP_ALL' and data != 'FLAG.SKIP_SEARCHLOCAL' and data != 'FLAG.SKIP_SEARCHENGINE' and data and os.path.exists(data)):
			self.fileName=data
			file=open(self.fileName)
			lf=file.read()
			file.close()
			self.initEvent(lf, False, False, True)
		elif(data != 'FLAG.SKIP_ALL' and data != 'FLAG.SKIP_SEARCHLOCAL' and data != 'FLAG.SKIP_SEARCHENGINE' and data and not os.path.exists(data)):
			del self.myData[os.path.basename(self.media)]
			mydb=open('%s/.lrcShow-X/lrcShow-X.db','w')
			pickler=pickle.Pickler(mydb,True)
			pickler.dump(self.myData)
			mydb.close()
			if(noTagInfo):
				self.searchLocalLrc(False, True)
			else:
				self.searchLocalLrc()
		elif(data == 'FLAG.SKIP_SEARCHLOCAL'):
			if(noTagInfo):
				self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>')
			else:
				self.downLoad()
		elif(data == 'FLAG.SKIP_SEARCHENGINE'):
			if(noTagInfo):
				self.searchLocalLrc(False, True)
			else:
				self.searchLocalLrc(False, False)
		elif(data=='FLAG.SKIP_ALL'):
			self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>')
		else:
			if(noTagInfo):
				self.searchLocalLrc(False, True)
			else:
				self.searchLocalLrc()
	
	def searchLocalLrcFromTag(self, k, path, dep):
		dep -= 1
		for lrcfile in glob.glob(os.path.join(path, '*.[Ll][Rr][Cc]')):
			filename = os.path.basename(lrcfile)
			if(self.title.lower() in filename.lower() and self.artist.lower() in filename.lower()):
				if(lrcfile not in k):
					k.append(lrcfile)
		if(dep < 0):
			return k
		else:
			sp = os.listdir(path)
			sp = map(lambda x: os.path.join(path, x), sp)
			sp = filter(lambda x: os.path.isdir(x), sp)
			for j in sp:
				k = self.searchLocalLrcFromTag(k, j, dep)
			return k
	
	def searchLocalLrcFromName(self, k, path, dep):
		dep -= 1
		for lrcfile in glob.glob(os.path.join(path, '*.[Ll][Rr][Cc]')):
			filename = os.path.basename(lrcfile)
			if(self.extInfo == os.path.splitext(filename)[0]):
				if(lrcfile not in k):
					k.append(lrcfile)
		if(dep < 0):
			return k
		else:
			sp = os.listdir(path)
			sp = map(lambda x: os.path.join(path, x), sp)
			sp = filter(lambda x: os.path.isdir(x), sp)
			for j in sp:
				k = self.searchLocalLrcFromName(k, j, dep)
			return k
	
	def searchLocal(self, rule, k, searchTmp, depTmp):
		for tmp in zip(searchTmp, depTmp):
			if(rule == 'TAG'):
				k = self.searchLocalLrcFromTag(k, tmp[0], tmp[1])
			elif(rule == 'NAME'):
				k = self.searchLocalLrcFromName(k, tmp[0], tmp[1])
		return k
	
	def getSearchLocalPath(self):
		if(len(self.path) >0 or self.searchMediaPath=='yes'):
			searchTmp=self.path[:]
			if(self.searchMediaPath=='yes'):
				searchTmp.append(self.extPath)
			return searchTmp
		else:
			return None

	def searchLocalLrc(self, searchNet = True, searchFromName = False):# just search local
		'''
		searchNet: set true, the application would search the lrc from net if no local lrc file, otherwise won't
		'''
		
		searchTmp = self.getSearchLocalPath()
		depTmp = map(lambda x: int(x), self.recursionDepth)
		if(searchTmp):
			k = []
			if(not searchFromName):
				k = self.searchLocal('TAG', k, searchTmp, depTmp)
			k = self.searchLocal('NAME', k, searchTmp, depTmp)

			if(len(k)==0):
				if(searchNet==True):
					self.downLoad()
				else:
					self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>')
			elif(len(k)==1):
				self.fileName=k[0]
				file=open(self.fileName)
				lf=file.read()
				file.close()
				if lf.strip() == "":
					if(searchNet==True):
						self.downLoad()
					else:
						self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>')
				else:
					self.initEvent(lf, False, False, True)
			else:
				self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>',True)
				self.chooseItermDialog2=chooseItem(self)
				for i in k:
					self.chooseItermDialog2.listBox.insertItem(k.index(i),unicode(i,self.locale))
				self.chooseItermDialog2.listBox.setCurrentRow(0)
				result2=self.chooseItermDialog2.exec_()
				if(result2==QDialog.Accepted):
					self.fileName=k[self.chooseItermDialog2.listBox.currentRow()]
					if(self.chooseItermDialog2.checkBox.isChecked()):
						self.myData[os.path.basename(self.media)]=self.fileName
						mydb=open('%s/.lrcShow-X/lrcShow-X.db' %self.homePath,'w')
						pickler=pickle.Pickler(mydb,True)
						pickler.dump(self.myData)
						mydb.close()
					file=open(self.fileName)
					lf=file.read()
					file.close()
					self.initEvent(lf, False, False, True)
				elif(result2==QDialog.Rejected):
					if(self.chooseItermDialog2.checkBox.isChecked()):
						self.myData[os.path.basename(self.media)]='FLAG.SKIP_SEARCHLOCAL'
						mydb=open('%s/.lrcShow-X/lrcShow-X.db' %self.homePath,'w')
						pickler=pickle.Pickler(mydb,True)
						pickler.dump(self.myData)
						mydb.close()
					if(searchNet==True):
						self.downLoad()
					else:
						self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>')
				else:
					pass
		else:
			if(searchNet==True):
				self.downLoad()
			else:
				self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>')
	
	def animateEffect_scroll(self, value):
		print self.hPos, self.num, value
		if(self.scrollType == 'always'):
			if(self.lineNum == 1):
				self.horizontalScrollBar().setValue(int(self.hPos-(1.0-value)*self.scrollDistance))
			else:
				self.verticalScrollBar().setValue(int(self.hPos-(1.0-value)*self.scrollDistance))
		elif(self.scrollType == 'jump'):
			if(value == 1.0):
				if(self.lineNum == 1):
					self.horizontalScrollBar().setValue(self.hPos)
				else:
					self.verticalScrollBar().setValue(self.hPos)
		elif(self.scrollType == 'smooth'):
			if(self.next_time > 700):
				limit = 700.0/self.next_time
				k = value/limit
				if(value <= limit):
					if(self.lineNum==1):
						self.horizontalScrollBar().setValue(int(self.hPos-(1-k)*self.scrollDistance))
					else:
						self.verticalScrollBar().setValue(int(self.hPos-(1-k)*self.scrollDistance))
			elif(200 < self.next_time <= 700):
				limit = 300.0/self.next_time
				k = value/limit
				if(value <= limit):
					if(self.lineNum==1):
						self.horizontalScrollBar().setValue(int(self.hPos-(1-k)*self.scrollDistance))
					else:
						self.verticalScrollBar().setValue(int(self.hPos-(1-k)*self.scrollDistance))
			else:
				if(value  == 1.0):
					if(self.lineNum == 1):
						self.horizontalScrollBar().setValue(self.hPos)
					else:
						self.verticalScrollBar().setValue(self.hPos)

	def highLight(self):
		if(self.lineNum != 1):
			self.moveCursor(QTextCursor.StartOfLine)
        		self.moveCursor(QTextCursor.NextBlock,QTextCursor.KeepAnchor)

	def nextDuration(self):# to scroll the lrc
		print 'last timer was just finished'
		self.num+=1
		if(self.num > len(self.tag)):
			return
		if(self.num != len(self.tag)):
			self.next_time = self.tag[self.num]-self.tag[self.num-1]
			if self.next_time < 0:
				self.next_time = 0
			if(self.lineNum==1):
				self.scrollDistance = self.fixLength+self.fragmentLength[self.num-1]/2+self.fragmentLength[self.num]/2
			else:
				self.scrollDistance = self.margin
			#if(self.next_time < 500):
				#interval = 200
			#else:
				#interval = 500
			self.hPos = self.hPos+self.scrollDistance
			self.initAnimateTimer()
			
			#self.myTimer.setDuration(self.next_time)
			#self.myTimer.start()
		else:
			if(self.lineNum==1):
				self.scrollDistance = self.fragmentLength[-2]/2+self.fragmentLength[-1]/2+self.fixLength
			else:
				self.scrollDistance = self.margin
			self.hPos = self.hPos+self.scrollDistance
			self.initAnimateTimer()
	
	def initAnimateTimer(self):
		self.highLight()
		self.myTimer.setDuration(self.next_time)
		self.myTimer.start()

	def initTime(self):
		time=int(self.di.getTimePoint())
		self.expectedTime=time+2500
	
	def checkTime(self):
		#print("checking time")
		time=int(self.di.getTimePoint())
		title=self.di.getTitle()
		try:
			title=title.encode(self.locale)
		except:
			title=''
		#if((abs(int(time)-self.expectedTime) > 200) and self.title != title):
			#self.otherFunctionsMenu_reloadAction_()
			#return
		if((abs(int(time)-self.expectedTime) > 200) and self.title==title and (self.originalLrc or self.fileName or self.usltLrc)):
			#if(self.myTimer.state() == 2):
				#self.myTimer.stop()
			#try:
				#self.animateTimer.stop()
			#except:
				#pass
			#self.moveCursor(QTextCursor.Start)
			self.myTimer.stop()
			self.goToCurrentPara()
		self.expectedTime=time+2500

	##########  block:def lrcAdjustMenu's function  ##########
	
	def seekSlow(self): # adjust function for delay
		if(self.fileName):
			self.lrcAdjustMenu_saveToFileAction.setEnabled(True)
		self.totalSeekTime -= 200
		self.myTimer.stop()
		self.moveCursor(QTextCursor.Start)
		self.myTimer.stop()
		self.goToCurrentPara()
	
	def seekFast(self): # as above, but opposite
		if(self.fileName):
			self.lrcAdjustMenu_saveToFileAction.setEnabled(True)
		self.totalSeekTime += 200
		self.myTimer.stop()
		self.moveCursor(QTextCursor.Start)
		self.myTimer.stop()
		self.goToCurrentPara()		
	
	def saveToFile(self):# save the offset into file
		file=open(self.fileName)
		content=unicode(file.read(),self.encoder).encode('utf8')
		file.close()
		offsetList=re.findall('\[offset:.*\]',content)
		if(len(offsetList) != 0):
			try:
				offsetOld=int(offsetList[0][8:-1])
			except:
				offsetOld=0
			offsetNew=offsetOld+self.totalSeekTime
			offsetLine='[offset:%s]' %str(offsetNew)
			content=re.sub('\[offset:.*\]',offsetLine,content)
		else:
			offsetLine='[offset:%s]\n' %str(self.totalSeekTime)
			content=offsetLine+content
		content=unicode(content,'utf8').encode(self.encoderToWrite)
		file=open(self.fileName,'w')
		file.write(content)
		file.close()
		self.lrcAdjustMenu_saveToFileAction.setEnabled(False)
		self.totalSeekTime=0
		self.encoder=self.encoderToWrite
		
	##########  block end  ##########
	
	##########  block: def amarokControlMenu's function  ##########
	
	def amarokControlMenu_playorpause(self):# as function's name
		if(self.amarokStatus=='stop' or self.amarokStatus=='pause'):
			self.di.playFunc()
		else:
			self.di.pauseFunc()
			
	def amarokControlMenu_stop(self):# as function's name
		self.di.stopFunc()
	
	def amarokControlMenu_prev(self):# as function's name
		self.di.prevFunc()
		
	def amarokControlMenu_next(self):# as function's name
		self.di.nextFunc()
		
	##########  block end  ###########
	
	########## block: def colorMenu's function  ##########
	
	def colorMenu_back(self):# as function's name
		rgbColor=QColorDialog.getColor(self.backGroundColor)
		if(rgbColor.isValid()):
			self.backGroundColor=rgbColor
			self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
			rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
			self.configFile.set('option','backroundcolor',rgbString)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
	
	def colorMenu_fore(self):# as function's name
		rgbColor=QColorDialog.getColor(self.foreGroundColor)
		if(rgbColor.isValid()):
			self.foreGroundColor=rgbColor
			self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
			rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
			self.configFile.set('option','fontcolor',rgbString)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
	
	def colorMenu_light(self):# as function's name
		rgbColor=QColorDialog.getColor(self.highLightColor)
		if(rgbColor.isValid()):
			self.highLightColor=rgbColor
			self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
			rgbString='%s,%s,%s' %(str(rgbColor.red()),str(rgbColor.green()),str(rgbColor.blue()))
			self.configFile.set('option','highlightcolor',rgbString)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
	
	def colorMenu_default(self):# as function's name
		self.backGroundColor=QColor(59,86,115)
		self.foreGroundColor=QColor(255,255,255)
		self.highLightColor=QColor(180,200,255)
		self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)
		self.configFile.set('option','backroundcolor','59,86,115')
		self.configFile.set('option','fontcolor','255,255,255')
		self.configFile.set('option','highlightcolor','180,200,255')
		self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))

	########## block end  ##########
	
	########## block: def setFontAction's fuction ##########
	
	def setFontAction_(self):# as function's name
		font,ok=QFontDialog.getFont(self.currentFont)
		if ok:
			self.currentFont=font
			self.setFont(font)
			self.margin=QFontMetrics(self.font()).height()+self.lineMargin
			self.setFixedHeight(self.margin*self.lineNum)
			self.myTimer.stop()
			self.initMainEvent()
			self.goToCurrentPara()
			self.configFile.set('option','fontinfo',str(font.toString().toUtf8()))
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
			
	
	########## block end  ##########
	
	########## block: def setLineAction's fuction ##########
	
	def setLineAction_(self):# as function's name
		num,ok=QInputDialog.getInteger(self,_('Set the show-line'),_('Please input the odd number 1-19, otherwise ignore'),self.lineNum,1,19,2)

		if(ok and num != self.lineNum and num in range(1,21,2)):
			self.myTimer.stop()
			if(num != 1 and self.lineNum != 1):
				self.lineNum=num
				self.initMainEvent()
				self.goToCurrentPara()
			elif(num==1 or self.lineNum==1):
				if(num != 1):
					self.displayMenu_normalAction.setEnabled(True)
					self.effectMenu_jumpAction.setEnabled(True)
					self.effectMenu_rollAction.setEnabled(True)
					self.scrollType = self.configFile.get('option', 'scrolltype')
					if(self.scrollType == 'jump'):
						self.effectMenu_jumpAction.setChecked(True)
					elif(self.scrollType == 'smooth'):
						self.effectMenu_rollAction.setChecked(True)
				self.lineNum=num
				if(self.fileName):
					file=open(self.fileName)
					lf=file.read()
					file.close()
					self.initEvent(lf, False, False, False)
				elif(self.originalLrc):
					self.initEvent(self.originalLrc, True, False, False)
				elif(self.usltLrc):
					p=embedLrc.embedLrc(self.media)
					lrc=p.detectLrc()
					if(lrc != None):
						self.initEvent(lrc, False, False, False)
					else:
						self.usltLrc=None
						self.otherFunctionsMenu_reloadAction_()
				else:
					lf='<p align="center">'+self.toPlainText()+'</p>'
					self.showInfo(lf)

			self.configFile.set('option','linenumber',str(num))
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
			
			self.setFixedHeight(self.margin*self.lineNum)
			
	########## block end  ##########
	
	########## block: def downloadMenu's fuction ##########
	
	def downloadMenu_yesAction_(self):# just change the status of auto downloading, but no downloading action would occur
		if(self.ifDownload=='yes'):
			pass
		else:
			self.downloadMenu_yesAction.setChecked(True)
			self.ifDownload='yes'
			self.configFile.set('option','download',self.ifDownload)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
	
	def downloadMenu_noAction_(self):
		if(self.ifDownload=='no'):
			pass
		else:
			self.downloadMenu_noAction.setChecked(True)
			self.ifDownload='no'
			self.configFile.set('option','download',self.ifDownload)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
	
	def downloadMenu_thisAction_(self):# downloading the lrc file from net but has 2 conditions: auto download is shut off and the lrc in window is from net
		try:
			unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite)
		except UnicodeEncodeError:
			QMessageBox.critical(self,_('Encode error'),_('An error occurs when encode the fetched lrc (%s) to saving encode (%s), ignore the download!\nNormally because the fetched lrc file has some characters that can not be encoded.\nIf this dialog shows frequancy, strongly recommend to turn off auto download, otherwise, you could set the encoding for saving to gb18030 or utf8 to avoid this problem.') %(self.netEncoder,self.encoderToWrite))
		else:
			if(self.saveToMediaPath=='yes' and self.extPath):
				pathTmp=self.extPath
			else:
				pathTmp=self.saveLrcPath
			if(os.path.exists(os.path.join(pathTmp,self.nameForSave))):
				a=QMessageBox.question(self,_('Ask'),_('A same name file exists, are you sure to overwrite?'),QMessageBox.Yes,QMessageBox.No)
				if(a==QMessageBox.Yes):
					try:
						file=open(os.path.join(pathTmp,self.nameForSave),'w')
					except:
						self.iconTray.showMessage('lrcShow-X', _('Fail in download lrc, please check the permission!'),1,self.trayInfoTime)
					else:
						self.saveToLocal(file, self.originalLrc, pathTmp)
						self.downloadMenu_thisAction.setEnabled(False)
						self.encoder=self.encoderToWrite
						if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
							self.iconTray.showMessage('lrcShow-X', _('Lrc saved : ')+unicode(self.nameForSave,self.locale), 1, self.trayInfoTime)
				else:
					pass
			else:
				try:
					file=open(os.path.join(pathTmp,self.nameForSave),'w')
				except:
					self.iconTray.showMessage('lrcShow-X', _('Fail in download lrc, please check the permission!'),1,self.trayInfoTime)
				else:
					file.write(unicode(self.originalLrc,self.netEncoder).encode(self.encoderToWrite))
					file.close()
					self.originalLrc=None
					self.downloadMenu_thisAction.setEnabled(False)
					self.fileName=os.path.join(pathTmp,self.nameForSave)
					self.encoder=self.encoderToWrite
					if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
						self.iconTray.showMessage('lrcShow-X', _('Lrc saved : ')+unicode(self.nameForSave,self.locale), 1, self.trayInfoTime)
	##########  block end (need test) ##########
	
	##########  block: def displayMenu's function  ##########
	
	def displayMenu_normalAction_(self):# normal display mode
		if(self.showMode=='normal' or self.lineNum==1):
			pass
		else:
			try:
				self.setAttribute(Qt.WA_TranslucentBackground, False)
			except:
				pass
			self.displayMenu_normalAction.setChecked(True)
			if(self.showMode=='osd'):
				self.showMode='normal'
				self.displayMenu_fullscreenAction.setEnabled(True)
				self.winFlags=Qt.Window
				if(self.displayMenu_topAction.isChecked()):
					self.setWindowFlags(self.winFlags|Qt.WindowStaysOnTopHint)
				else:
					self.setWindowFlags(self.winFlags)
				self.setWindowIcon(QIcon('./icon/logo.png'))
				self.show()
			elif(self.showMode=='fullscreen'):
				self.setMouseTracking(False)
				if(self.hideMouseTimer.isActive()):
					self.hideMouseTimer.stop()
				if(self.viewport().cursor().shape() != Qt.ArrowCursor):
					self.viewport().setCursor(QCursor(Qt.ArrowCursor))
				self.showMode='normal'
				self.displayMenu_osdAction.setEnabled(True)
				self.setLineAction.setEnabled(True)
				self.displayMenu_topAction.setEnabled(True)
				
				self.lineNum=int(self.configFile.get('option','linenumber'))
				self.showNormal()
				self.setFixedHeight(self.margin*self.lineNum)
				self.resize(self.widthBefore,self.size().height())
				self.move(self.posBefore)
				self.myTimer.stop()
				self.initMainEvent()
				if(self.originalLrc or self.fileName or self.usltLrc):
					self.goToCurrentPara()
	
	def displayMenu_fullscreenAction_(self):# fullscreen display mode, the cursor would be auto hiden
		if(self.showMode=='fullscreen'):
			pass
		else:
			try:
				self.setAttribute(Qt.WA_TranslucentBackground, False)
			except:
				pass
			self.showMode='fullscreen'
			self.displayMenu_fullscreenAction.setChecked(True)
			self.displayMenu_osdAction.setEnabled(False)
			self.setLineAction.setEnabled(False)
			self.displayMenu_topAction.setEnabled(False)
			self.widthBefore=self.size().width()
			self.posBefore=self.pos()
			self.showFullScreen()
			self.lineNum=QApplication.desktop().height()/self.margin
			self.myTimer.stop()
			self.initMainEvent()
			if(self.originalLrc or self.fileName or self.usltLrc):
				self.goToCurrentPara()
			self.setMouseTracking(True)
			self.currentCursorPos=QPoint(0,0)
			self.lastCursorPos=QPoint(0,0)
			self.hideMouseTimer.start(2000)
	
	def displayMenu_osdAction_(self):# osd display mode, no title bar, can't resize the window. pyqt3 version in this mode, must stay on top, pyqt4 may be not
		if(self.showMode=='osd'):
			pass
		else:
			try:
				self.setAttribute(Qt.WA_TranslucentBackground, False)
			except:
				pass
			self.showMode='osd'
			self.displayMenu_osdAction.setChecked(True)
			self.displayMenu_fullscreenAction.setEnabled(False)
			self.winFlags=Qt.CustomizeWindowHint
			if(self.displayMenu_topAction.isChecked()):
				self.setWindowFlags(self.winFlags|Qt.WindowStaysOnTopHint)
			else:
				self.setWindowFlags(self.winFlags)
			self.setWindowIcon(QIcon('./icon/logo.png'))
			self.show()
	
	def displayMenu_transparencyAction_(self, e):
		if(e):
			self.transEffect = 'yes'
		else:
			self.transEffect = 'no'
		self.setAttribute(Qt.WA_TranslucentBackground, e)
		self.setAttribute(Qt.WA_NoSystemBackground, e)
		self.displayMenu_transparencyAction.setChecked(e)
		self.initColor(self.backGroundColor,self.foreGroundColor,self.highLightColor)

	def displayMenu_topAction_(self,bool):# special display mode in pyqt4 version
		if(bool):
			self.setWindowFlags(self.winFlags|Qt.WindowStaysOnTopHint)
			self.show()
			self.topIsChecked=True
		else:
			self.setWindowFlags(self.winFlags)
			self.show()
			self.topIsChecked=False

	###########  block end  ##########
	
	###########  block: def display effect  #############
	
	def switchEffect_jump(self):
		if(self.scrollType != 'jump'):
			self.scrollType = 'jump'
			self.configFile.set('option','scrolltype', self.scrollType)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
			self.myTimer.stop()
			self.initMainEvent()
			self.goToCurrentPara()
	
	def switchEffect_roll(self):
		if(self.scrollType != 'smooth'):
			self.scrollType = 'smooth'
			self.configFile.set('option','scrolltype', self.scrollType)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
			self.myTimer.stop()
			self.initMainEvent()
			self.goToCurrentPara()
	
	def switchEffect_alwaysRoll(self):
		if(self.scrollType != 'always'):
			self.scrollType = 'always'
			self.configFile.set('option','scrolltype', self.scrollType)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
			self.myTimer.stop()
			self.initMainEvent()
			self.goToCurrentPara()
	
	########## block: def openLrcEditorAction's function ##########
	
	def getStatusMessage(self, tmpType):
		#_('Location: ')+unicode(self.fileName, self.locale)
		if(tmpType == _('local')):
			m = unicode(self.fileName, self.locale)
		elif(tmpType == _('internet')):
			m = _('unknown')
		elif(tmpType == _('embed')):
			m = unicode(self.media, self.locale)
		else:
			m = _('unknown')
		return _('Location: ')+m+'                   '+_('Type: ')+tmpType
		
	def playerStatusSyncToEditor(self):
		if(self.amarokStatus=='pause'):
			self.editBox.playorPause.setIcon(QIcon('./icon/amarok_play.png'))
			self.editBox.playorPause.setText(_('Play(&P)'))
		elif(self.amarokStatus=='playing') :
			self.editBox.playorPause.setIcon(QIcon('./icon/amarok_pause.png'))
			self.editBox.playorPause.setText(_('Pause(&P)'))
			self.editBox.stop.setEnabled(True)
		elif(self.amarokStatus=='stop') :
			self.editBox.playorPause.setIcon(QIcon('./icon/amarok_play.png'))
			self.editBox.playorPause.setText(_('Play(&P)'))
			self.editBox.stop.setEnabled(False)
			self.editBox.downloadAction.setEnabled(False)
	
	def dataSyncToEditor(self):
		if(self.saveToMediaPath == 'yes' and self.extPath):
			tmpSavePath = self.extPath
		else:
			tmpSavePath = self.saveLrcPath
			
		if(self.fileName):
			f = open(self.fileName)
			tmpFile = f.read()
			f.close()
			tmpType = _('local')
			tmpSaveTarget = self.fileName
		elif(self.originalLrc):
			tmpFile = self.originalLrc
			tmpType = _('internet')
			tmpSaveTarget = tmpSavePath
		elif(self.usltLrc):
			tmpFile = self.usltLrc
			tmpType = _('embed')
			tmpSaveTarget = self.media
		else:
			tmpFile = None
			tmpType = _('unknown')
			tmpSaveTarget = tmpSavePath
		
		if(self.amarokStatus == 'stop'):
			self.editBox.artist = ''
			self.editBox.title = ''
			self.editBox.nameForSave = ' - .lrc'
			self.editBox.downloadAction.setEnabled(False)
		else:
			self.editBox.artist = self.artist
			self.editBox.title = self.title
			self.editBox.nameForSave = self.nameForSave
			self.editBox.downloadAction.setEnabled(True)

		self.editBox.lrcTagType = self.lrcTagType
		self.editBox.asTrackName = self.asTrackName
		self.editBox.proxy = self.proxy
		self.editBox.encoderForSave = self.encoderToWrite
		self.editBox.savePath = tmpSavePath
		self.editBox.saveTarget = tmpSaveTarget
		self.editBox.lrcType = tmpType
		
		try:
			self.editBox.status.removeWidget(self.messageLabel)
		except:
			pass
		
		self.messageLabel = QLabel(self.getStatusMessage(tmpType), None)
		self.editBox.status.addWidget(self.messageLabel)
		
		if(tmpFile):
			if(self.originalLrc):
				coder = self.netEncoder
			else:
				coder = self.encoder
			content = unicode(tmpFile, coder)
		else:
			try:
				content = '[ti:%s]\n[ar:%s]\n[al:]\n[by:%s]\n' % (unicode(self.title, self.locale), unicode(self.artist, self.locale), os.getenv("USER"))
			except AttributeError:
				content = '[ti:]\n[ar:]\n[al:]\n[by:%s]\n' %os.getenv("USER")
		self.editBox.lrcArea.setPlainText(content)
		self.editBox.saveAction.setEnabled(False)
	
	def saveSyncMode(self, bool):
		if(bool):
			self.editorSyncMode = 'yes'
			self.editBox.syncModeAction.setIcon(QIcon('./icon/sync_unlock.png'))
		else:
			self.editorSyncMode = 'no'
			self.editBox.syncModeAction.setIcon(QIcon('./icon/sync_lock.png'))

		self.configFile.set('option','editorsyncmode',self.editorSyncMode)
		self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
	
	def openLrcEditorAction_(self):# as function's name

		self.editBox = lrcEditorQt4(self, self.locale, self.di, self.shortCut_insert, self.shortCut_cancel, self.editorSyncMode)
		
		self.dataSyncToEditor()
		self.playerStatusSyncToEditor()

		self.editBox.connect(self.editBox.lrcArea,SIGNAL("textChanged()"),self.editBox.saveEnable)
		self.editBox.connect(self.editBox.syncModeAction, SIGNAL("triggered(bool)"), self.saveSyncMode)
		self.connect(self.editBox.playorPause, SIGNAL("triggered()"), self.amarokControlMenu_playorpause)
		self.connect(self.editBox.stop, SIGNAL("triggered()"), self.amarokControlMenu_stop)
		self.connect(self.editBox.prevAction, SIGNAL("triggered()"), self.amarokControlMenu_prev)
		self.connect(self.editBox.nextAction, SIGNAL("triggered()"), self.amarokControlMenu_next)
		self.connect(self.editBox.syncManually, SIGNAL("triggered()"), self.dataSyncToEditor)

		self.editBox.show()
	
	######## block end  ###########
	
	##########  block: def setSearchEngineAction's function  #########

	def setSearchEngineAction_(self):# as function's name
		engineList=QStringList()
		for i in glob.glob('./engines/engine_*.py'):
			i=os.path.basename(i)[7:-3]
			engineList.append(i)
		index=engineList.indexOf(self.configFile.get('option','searchengine'))
		
		self.chooseEngineDialog=chooseEngine(self)
		self.chooseEngineDialog.combo.addItems(engineList)
		self.chooseEngineDialog.combo.setCurrentIndex(index)
		
		result=self.chooseEngineDialog.exec_()
		if(result==QDialog.Accepted):
			engine=self.chooseEngineDialog.combo.currentText()
			self.searchEngine=str(engine.toUtf8())
			self.configFile.set('option','searchengine',self.searchEngine)
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
			if(self.chooseEngineDialog.searchNow.isChecked()):
				self.otherFunctionsMenu_searchAction_()
	
	########## block end  ##########
	
	########## block: def otherFunctionsMenu's function ##########
	
	def otherFunctionsMenu_searchAdvancedAction_(self):
		self.advanceSearchBox=advancedSearchNet(self,self.searchEngine,self.artist,self.title,self.locale,self.proxy,None)
		self.connect(self.advanceSearchBox.testButton,SIGNAL("clicked()"),self.advDownLrc)
		self.connect(self.advanceSearchBox.returnButton,SIGNAL("clicked()"),self.otherFunctionsMenu_reloadAction_)
		result=self.advanceSearchBox.exec_()
		if(result==QDialog.Accepted):
			if(self.advanceSearchBox.download.isChecked()):
				self.advDownLrc(True)
				self.downloadMenu_thisAction.setEnabled(False)
			else:
				self.advDownLrc()
	
	def advDownLrc(self,withDownload=False): 
		txt=_('Searching the lrc on ')+self.advanceSearchBox.table.item(self.advanceSearchBox.table.currentRow(),2).text().toUtf8()+_(' lyrics server...')
		self.showInfo('<p align="center">'+txt+'</p>',True)
		bList=self.advanceSearchBox.currentUrlList[self.advanceSearchBox.currentRow]
		self.downAfterChoose=downAfterChoose(self,bList[0],self.proxy,bList[1],withDownload)
		self.downAfterChoose.start()
	
	def otherFunctionsMenu_searchAction_(self):# force the app to search lrc from net whatever the track has lrc
		#di=dbusInterface(self.player,self.obj1,self.obj2,self.obj3)
		self.title=self.di.getTitle().encode(self.locale)
		self.artist=self.di.getArtist().encode(self.locale)
		self.media=unquote_plus(self.di.getMediaFile().replace('file://','').encode(self.locale))
		self.extInfo=os.path.splitext(os.path.basename(self.media))[0]
		self.extPath=os.path.dirname(self.media)
		if(self.asTrackName=='yes'):
			self.nameForSave=self.extInfo+'.lrc'
		else:
			self.nameForSave = ('%s - %s.lrc' %(self.artist,self.title)).translate(None, '<>/\\|:"*?')
		self.fileName=None  #maybe needn't
		self.originalLrc=None
		self.usltLrc=None
		self.downloadMenu_thisAction.setEnabled(False)
		self.downLoad(True)
	
	def otherFunctionsMenu_reloadAction_(self):# re-do the process just like the current track is switched to
		if(self.amarokStatus=='playing'):# when the current track is playing
			self.customEvent(myEvent('engineStateChange',self.amarokStatus))
		elif(self.amarokStatus=='pause'):# when the current track is pausing
			if(self.myTimer.state() == 2):
				self.customEvent(myEvent('engineStateChange',self.amarokStatus))
			else:
				self.customEvent(myEvent('startup',self.amarokStatus))
		else:#it could not happen when Amarok in stop status
			pass
			
	
	def otherFunctionsMenu_cancelAction_(self):# let the lrc go hell, if has
		if(self.includeCancel=='yes'):
			d=False
		else:
			d=True
		self.fileName=None
		self.originalLrc=None
		self.usltLrc=None
		self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>',d)
		
	def otherFunctionsMenu_readUsltAction_(self):
		p=embedLrc.embedLrc(self.media)
		lrc=p.detectLrc()
		if(lrc != None):
			self.fileName=None
			self.originalLrc=None
			self.usltLrc=lrc
			self.initEvent(lrc, False, False, False)
			if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
				self.iconTray.showMessage('lrcShow-X', _('Using embedded lrc'), 1, self.trayInfoTime)
		else:
			QMessageBox.information(self,_('Notice'),_('No lrc in current media file'))
	
	def otherFunctionsMenu_insertUsltAction_(self, fromAutoEmbed = False):
		if(self.originalLrc):
			if(fromAutoEmbed):
				if(self.autoEmbedFromNet == 'yes'):
					lrc=self.originalLrc
					encoding=self.netEncoder
				else:
					lrc = None
			else:
				lrc=self.originalLrc
				encoding=self.netEncoder

		elif(self.fileName):
			if(fromAutoEmbed):
				if(self.autoEmbedFromLocal == 'yes'):
					ff=open(self.fileName)
					lrc=ff.read()
					ff.close()
					encoding=self.encoder
				else:
					lrc = None
			else:
				ff=open(self.fileName)
				lrc=ff.read()
				ff.close()
				encoding=self.encoder
			
		elif(self.usltLrc):
			lrc=None
			if(not fromAutoEmbed):
				QMessageBox.information(self,_('Notice'),_('Lrc in media file is being used'))
			
		else:
			lrc=None
			if(not fromAutoEmbed):
				QMessageBox.information(self,_('Notice'),_('No lrc is being used'))
			
		if(lrc):
			p = embedLrc.embedLrc(self.media)
			lrcTmp = p.detectLrc()
			if(fromAutoEmbed and lrcTmp != None ):
				pass
			else:
				lrc=unicode(lrc,encoding).encode('utf8')
				p.insertLrc(self.lrcTagType,lrc)
				if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
					self.iconTray.showMessage('lrcShow-X', _('Succeed in embedding lrc'), 1, self.trayInfoTime)

	def otherFunctionsMenu_deleteUsltAction_(self):
		p=embedLrc.embedLrc(self.media)
		flag=p.deleteLrc(self.lrcTagType)
		if flag:
			if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
				self.iconTray.showMessage('lrcShow-X', _('Succeed in deleting embedded lrc'), 1, self.trayInfoTime)
		else:
			QMessageBox.information(self,_('Notice'),_('No lrc in ')+self.lrcTagType+_(' tag of current media file'))
	
	def otherFunctionsMenu_deleteAllUsltAction_(self):
		typeList=['id3v2-uslt','apetag','lyrics3v2','lyrics3v1','id3v2-sylt']
		existList=[]
		p=embedLrc.embedLrc(self.media)
		for i in typeList:
			flag=p.deleteLrc(i)
			if flag:
				existList.append(i)
		if(len(existList)==0):
			QMessageBox.information(self,_('Notice'),_('No lrc in current media file'))
		else:
			if(self.trayIconNotify=='yes' and self.enableTrayIcon=='yes'):
				self.iconTray.showMessage('lrcShow-X', _('Succeed in deleting all embedded lrcs'), 1, self.trayInfoTime)
	
	def otherFunctionsMenu_otherSetting_(self):# configurate the app
		settingDialog=otherSettingQt4(self)
		settingDialog.itemBox.setCurrentRow(0)
		settingDialog.behaviorPage.minWidth.setValue(self.minWidth)
		settingDialog.behaviorPage.marginValue.setValue(self.lineMargin)
		settingDialog.trayPage.trayTime.setValue(self.trayInfoTime/1000)
		if(self.autoEmbed == 'yes'):
			settingDialog.normalPage.autoEmbed.setChecked(True)
		if(self.autoEmbedFromLocal == 'yes'):
			settingDialog.normalPage.autoEmbedFromLocal.setChecked(True)
		if(self.autoEmbedFromNet == 'yes'):
			settingDialog.normalPage.autoEmbedFromNet.setChecked(True)
		if(self.noLrc=='normal'):
			settingDialog.behaviorPage.groupHide.normal.setChecked(True)
		elif(self.noLrc=='hide'):
			settingDialog.behaviorPage.groupHide.hide.setChecked(True)
		else:
			settingDialog.behaviorPage.groupHide.mini.setChecked(True)
		if(self.includeCancel=='yes'):
			settingDialog.behaviorPage.groupHide.includeCheckBox.setChecked(True)
		#if(self.autoInsertAmarok=='yes'):
			#settingDialog.normalPage.autoInsert.setChecked(True)
		if(self.transparency=='yes'):
			settingDialog.behaviorPage.enableTransparency.setChecked(True)
		if(self.rememberOpacity=='yes'):
			settingDialog.behaviorPage.rememberOpacity.setChecked(True)
		if(self.titleBarInfo=='yes'):
			settingDialog.behaviorPage.autoTitleBar.setChecked(True)
		if(self.rememberShowMode=='yes'):
			settingDialog.behaviorPage.rememberLastShowMode.setChecked(True)
		if(self.asTrackName=='yes'):
			settingDialog.normalPage.asTrackName.setChecked(True)
		if(self.completeTag=='yes'):
			settingDialog.normalPage.completeTagSearch.setChecked(True)
		if(self.useUslt=='yes'):
			settingDialog.normalPage.lrcInMedia.setChecked(True)
		if(self.filterLyrics=='yes'):
			settingDialog.limitPage.filterCheckBox.setChecked(True)
		else:
			settingDialog.limitPage.filterCheckBox.setChecked(False)
		if(self.nullLine=='yes'):
			settingDialog.limitPage.nullLine.setChecked(True)
		if(self.saveToMediaPath=='yes'):
			settingDialog.lrcPathPage.saveToMediaPath.setChecked(True)
		if(self.searchMediaPath=='yes'):
			settingDialog.lrcPathPage.searchMediaPath.setChecked(True)
		settingDialog.limitPage.filterKeyWold.setText(unicode(self.filterRule,'utf8'))
		tmpPathList=map(lambda x:unicode(x,self.locale),self.path)
		if(self.enableMultiEngines == 'yes'):
			settingDialog.multiSearchPage.multiSearch.setChecked(True)
		for k in glob.glob('./engines/engine_*.py'):
			j=os.path.basename(k)[7:-3]
			if(j not in self.multiEngines):
				settingDialog.multiSearchPage.allEngines.addItem(j)
		for m in self.multiEngines:
			settingDialog.multiSearchPage.userEngines.addItem(m)
		for i in tmpPathList:
			settingDialog.lrcPathPage.insertItem(QTableWidgetItem(i,0), self.recursionDepth[tmpPathList.index(i)])
		settingDialog.lrcPathPage.savePath.setText(unicode(self.saveLrcPath,self.locale))
		index=settingDialog.normalPage.strList.index(self.encoderToWrite)
		settingDialog.normalPage.comboBox.setCurrentIndex(index)
		
		index_=settingDialog.normalPage.strTagList.index(self.lrcTagType)
		settingDialog.normalPage.comboBoxType.setCurrentIndex(index_)
		if(self.proxy):
			settingDialog.normalPage.proxy.setText(self.proxy['http'])
		else:
			pass
		if(self.filterCap=='yes'):
			settingDialog.limitPage.filterCap.setChecked(True)
		if(self.enableTrayIcon=='yes'):
			settingDialog.trayPage.enableTray.setChecked(True)
		else:
			settingDialog.trayPage.enableNotify.setEnabled(False)
			settingDialog.trayPage.trayTime.setEnabled(False)
		if(self.trayIconNotify=='yes'):
			settingDialog.trayPage.enableNotify.setChecked(True)
		
		settingResult=settingDialog.exec_()
		if(settingResult==QDialog.Accepted):
			self.minWidth=settingDialog.behaviorPage.minWidth.value()
			self.setMinimumWidth(self.minWidth)
			self.configFile.set('option','minwidth',str(self.minWidth))
			if(self.lineMargin != settingDialog.behaviorPage.marginValue.value()):
				self.lineMargin = settingDialog.behaviorPage.marginValue.value()
				self.configFile.set('option', 'linemargin', str(self.lineMargin))
				self.margin=QFontMetrics(self.font()).height()+self.lineMargin
				self.setFixedHeight(self.margin*self.lineNum)
				self.otherFunctionsMenu_reloadAction_()
			
			self.trayInfoTime=settingDialog.trayPage.trayTime.value()*1000
			self.configFile.set('option','trayinfotime',str(self.trayInfoTime))
			if(settingDialog.behaviorPage.groupHide.normal.isChecked()):
				self.noLrc='normal'
			elif(settingDialog.behaviorPage.groupHide.hide.isChecked()):
				self.noLrc='hide'
			elif(settingDialog.behaviorPage.groupHide.mini.isChecked()):
				self.noLrc='mini'
			self.configFile.set('option','nolrc',self.noLrc)
			if(settingDialog.behaviorPage.enableTransparency.isChecked()):
				self.transparency='yes'
			else:
				self.transparency='no'
				self.setWindowOpacity(1.0)
			self.configFile.set('option','transparency',self.transparency)
			if(settingDialog.behaviorPage.rememberOpacity.isChecked()):
				self.rememberOpacity='yes'
			else:
				self.rememberOpacity='no'
			self.configFile.set('option','rememberopacity',self.rememberOpacity)	
			if(settingDialog.behaviorPage.groupHide.includeCheckBox.isChecked()):
				self.includeCancel='yes'
			else:
				self.includeCancel='no'
			self.configFile.set('option','includecancel',self.includeCancel)
			if(settingDialog.normalPage.asTrackName.isChecked()):
				self.asTrackName='yes'
				try:
					self.nameForSave=self.extInfo+'.lrc'
				except:
					pass
			else:
				self.asTrackName='no'
				try:
					self.nameForSave = ('%s - %s.lrc' %(self.artist,self.title)).translate(None, '<>/\\|:"*?')
				except:
					pass
			self.configFile.set('option','astrackname',self.asTrackName)
			if(settingDialog.normalPage.autoEmbedFromLocal.isChecked()):
				self.autoEmbedFromLocal = 'yes'
			else:
				self.autoEmbedFromLocal = 'no'
			self.configFile.set('option', 'autoembedfromlocal', self.autoEmbedFromLocal)
			if(settingDialog.normalPage.autoEmbedFromNet.isChecked()):
				self.autoEmbedFromNet = 'yes'
			else:
				self.autoEmbedFromNet = 'no'
			self.configFile.set('option', 'autoembedfromnet', self.autoEmbedFromNet)
			if(settingDialog.normalPage.autoEmbed.isChecked()):
				self.autoEmbed = 'yes'
			else:
				self.autoEmbed = 'no'
			self.configFile.set('option', 'autoembed', self.autoEmbed)
			if(settingDialog.normalPage.lrcInMedia.isChecked()):
				self.useUslt='yes'
			else:
				self.useUslt='no'
			self.configFile.set('option','useuslt',self.useUslt)
			if(settingDialog.behaviorPage.autoTitleBar.isChecked()):
				self.titleBarInfo='yes'
			else:
				self.titleBarInfo='no'
			self.configFile.set('option','titlebarinfo',self.titleBarInfo)
			if(settingDialog.behaviorPage.rememberLastShowMode.isChecked()):
				self.rememberShowMode='yes'
			else:
				self.rememberShowMode='no'
			self.configFile.set('option','remembershowmode',self.rememberShowMode)
			if(settingDialog.normalPage.completeTagSearch.isChecked()):
				self.completeTag='yes'
			else:
				self.completeTag='no'
			self.configFile.set('option','completetag',self.completeTag)
			if(settingDialog.limitPage.filterCheckBox.isChecked() and not settingDialog.limitPage.filterKeyWold.text().isEmpty()):
				self.filterLyrics='yes'
			else:
				self.filterLyrics='no'
			self.configFile.set('option','filterlyrics',self.filterLyrics)
			if(settingDialog.limitPage.nullLine.isChecked()):
				self.nullLine='yes'
			else:
				self.nullLine='no'
			self.configFile.set('option','nullline',self.nullLine)
			if(settingDialog.limitPage.filterCap.isChecked()):
				self.filterCap='yes'
			else:
				self.filterCap='no'
			self.configFile.set('option','filtercap',self.filterCap)
			self.filterRule=settingDialog.limitPage.filterKeyWold.text().toUtf8()
			self.configFile.set('option','filterrule',str(self.filterRule))
			if(settingDialog.lrcPathPage.saveToMediaPath.isChecked()):
				self.saveToMediaPath='yes'
			else:
				self.saveToMediaPath='no'
			self.configFile.set('option','savetomediapath',self.saveToMediaPath)
			if(settingDialog.lrcPathPage.searchMediaPath.isChecked()):
				self.searchMediaPath='yes'
			else:
				self.searchMediaPath='no'
			self.configFile.set('option','searchmediapath',self.searchMediaPath)
			if(settingDialog.trayPage.enableTray.isChecked()):
				self.enableTrayIcon='yes'
				if(not self.iconTray.isVisible()):
					self.iconTray.setVisible(True)
			else:
				self.enableTrayIcon='no'
				if(self.isHidden()):
					self.show()
				if(self.iconTray.isVisible()):
					self.iconTray.setVisible(False)
			self.configFile.set('option','trayicon',self.enableTrayIcon)
			if(settingDialog.multiSearchPage.multiSearch.isChecked()):
				self.enableMultiEngines = 'yes'
			else:
				self.enableMultiEngines = 'no'
			self.configFile.set('option','enablemultiengines',self.enableMultiEngines)
			tmpMultiEngines = ''
			for i in range(settingDialog.multiSearchPage.userEngines.count()):
				tmpMultiEngines += '%s,' %settingDialog.multiSearchPage.userEngines.item(i).text()
				self.multiEngines = tmpMultiEngines.split(',')[0:-1]
			self.configFile.set('option','multiengines',tmpMultiEngines)
			if(settingDialog.trayPage.enableNotify.isChecked()):
				self.trayIconNotify='yes'
			else:
				self.trayIconNotify='no'
			self.configFile.set('option','trayiconnotify',self.trayIconNotify)
			s1 = ''
			s3 = ''
			for j in range(0,settingDialog.lrcPathPage.rowNumber):
				s1+='%s,' %settingDialog.lrcPathPage.table.item(j,0).text().toUtf8()
				s3+='%s,' %settingDialog.lrcPathPage.table.cellWidget(j, 1).currentText()
			s2=settingDialog.lrcPathPage.savePath.text().toUtf8()
			self.path=map(lambda x:unicode(x,'utf8').encode(self.locale),s1.split(',')[0:-1])
			self.recursionDepth = s3.split(',')[0:-1]
			self.saveLrcPath=unicode(s2,'utf8').encode(self.locale)
			self.configFile.set('option','lrcpath',str(s1))
			self.configFile.set('option','savelrcpath',str(s2))
			self.configFile.set('option', 'recursiondepth', str(s3))
			self.encoderToWrite=str(settingDialog.normalPage.comboBox.currentText().toUtf8())
			self.configFile.set('option','encoder',str(self.encoderToWrite))
			self.lrcTagType=str(settingDialog.normalPage.comboBoxType.currentText().toUtf8())
			self.configFile.set('option','lrctagtype',str(self.lrcTagType))
			pp=settingDialog.normalPage.proxy.text()
			if(pp.isEmpty()):
				self.proxy=None
				self.configFile.set('option','proxy','no')
			else:
				self.proxy={'http':str(pp)}
				self.configFile.set('option','proxy',str(pp))
				
			shortcutName=['fullscreen','osd','normal','insert','cancel','editor','save','delay','advance','fastbar','refresh']
			for i in range(len(shortcutName)):
				self.configFile.set('shortcuts',shortcutName[i],settingDialog.shortcutPage.shortcutValue[i])
			
			self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
			
			(self.shortCut_fullscreen,self.shortCut_osd,self.shortCut_normal,self.shortCut_insert,self.shortCut_cancel,self.shortCut_editor,self.shortCut_save,self.shortCut_delay,self.shortCut_advance,self.shortCut_fastbar,self.shortCut_refresh)=map(lambda x: QKeySequence.fromString(x),settingDialog.shortcutPage.shortcutValue)
		
	
	########## block end  ##########
	
	########## block: def setStrategyAction's function  #########
	
	def setStrategyAction_(self):# as function's name
		data=self.myData.get(os.path.basename(self.media),False)
		if(data):
			self.relationDialog=hasRelationDialog(self)
			self.relationDialog.trackLabel.setText(unicode(os.path.basename(self.media), self.locale))
			self.relationDialog.tagLabel.setText(unicode(self.artist,self.locale)+u' - '+unicode(self.title,self.locale))
			if(data=='FLAG.SKIP_SEARCHLOCAL'):
				content=_('Do not search local')
			elif(data=='FLAG.SKIP_SEARCHENGINE'):
				content=_('Do not search web')
			elif(data=='FLAG.SKIP_ALL'):
				content=_('Do not search at all')
			else:
				content=unicode(data,self.locale)
			self.relationDialog.relationLabel.setText(content)
			result3=self.relationDialog.exec_()
			if(result3==1):
				del self.myData[os.path.basename(self.media)]
				mydb=open('%s/.lrcShow-X/lrcShow-X.db' %self.homePath,'w')
				pickler=pickle.Pickler(mydb,True)
				pickler.dump(self.myData)
				mydb.close()
			else:
				pass	
		else:
			if(self.fileName != None):
				tmpFile = unicode(self.fileName, self.locale)
			else:
				tmpFile = None
			self.relationDialog=hasNoRelationDialog(self, tmpFile)
			self.relationDialog.trackLabel.setText(unicode(os.path.basename(self.media), self.locale))
			self.relationDialog.tagLabel.setText(unicode(self.artist,self.locale)+u' - '+unicode(self.title,self.locale))
			result3=self.relationDialog.exec_()
			if(result3==1):
				if(self.relationDialog.comboBox.currentIndex()==1):
					content='FLAG.SKIP_SEARCHLOCAL'
				elif(self.relationDialog.comboBox.currentIndex()==2):
					content='FLAG.SKIP_SEARCHENGINE'
				elif(self.relationDialog.comboBox.currentIndex()==3):
					content='FLAG.SKIP_ALL'
				elif(self.relationDialog.comboBox.currentIndex()==4):
					content=str(self.relationDialog.pathLine.text().toLocal8Bit())
				self.myData[os.path.basename(self.media)]=content
				mydb=open('%s/.lrcShow-X/lrcShow-X.db' %self.homePath,'w')
				pickler=pickle.Pickler(mydb,True)
				pickler.dump(self.myData)
				mydb.close()
			else:
				pass
	########## block end  ##########

	
	########## block: def viewHelpAction's function  #########
	
	def viewHelpAction_(self):# open the build-in help-browser
		helpBrowser=helpWindow(self)
		helpBrowser.show()
	
	######### block end  #########
	
	#########  block:def aboutAction's function  #########
	
	def aboutAction_(self):# about lrcShow-II
		QMessageBox.about(self,_('About lrcShow-X'),_('Version : lrcShow-X-1.4.0\nSummary : Genernal script of media player  for showing lrc\nAuthor : sanfanling, OutLikeAShoe\nLicense: GPL-v2.0\nBug report : https://bugs.launchpad.net/lrcshow-x\nTranslator : %s') %_('translator_credits'))
		
	######### block end  #########
	
	######### block:def aboutQtAction's function  #######
	
	def aboutQtAction_(self):# about Qt
		QMessageBox.aboutQt(self,_('About Qt...'))
		
	######### block end  ######################
	
	
	
	def initColor(self,a,b,c):# to set colors
		#if(self.transEffect == 'yes'):
			#self.setStyleSheet('QTextBrowser#mainBox {background-color: QColor(0,0,0,0,0); color: %s; selection-background-color: QColor(0,0,0,0,0); selection-color: %s}' %(b.name(), c.name()))
		#else:
			#self.setStyleSheet('QTextBrowser#mainBox {background-color: %s; color: %s; selection-background-color: %s; selection-color: %s}' %(a.name(), b.name(), a.name(), c.name()))
		if(self.transEffect == 'yes'):
			a.setAlpha(0)
		else:
			a.setAlpha(255)
		pl=QPalette()
		pl.setColor(QPalette.Window, a)
		pl.setColor(QPalette.Base, a)
		pl.setColor(QPalette.Text, b)
		pl.setColor(QPalette.Highlight, a)
		pl.setColor(QPalette.HighlightedText, c)
		self.setPalette(pl)
			
	def contextMenuEvent(self,ev):# show the right click menu
		self.myMenu.popup(ev.globalPos())

	def mouseDoubleClickEvent(self,ev):# to show/hide the fast setting bar
		if(self.toolMenuBar.isHidden()):
			self.toolMenuBar.show()
		else:
			self.toolMenuBar.hide()
	
	############# define shortcut  #########################
	
	def keyPressEvent(self,ev):
		if(ev.key()==self.shortCut_delay and self.lrcAdjustMenu_delayAction.isEnabled()):
			self.seekSlow()
		elif(ev.key()==self.shortCut_advance and self.lrcAdjustMenu_advancedAction.isEnabled()):
			self.seekFast()
		elif(ev.key()==self.shortCut_save and self.lrcAdjustMenu_saveToFileAction.isEnabled()):
			self.saveToFile()
		elif(ev.key()==self.shortCut_fullscreen and self.showMode=='normal'):
			self.displayMenu_fullscreenAction_()
		elif(ev.key()==self.shortCut_normal and (self.showMode=='fullscreen' or self.showMode=='osd')):
			self.displayMenu_normalAction_()
		elif(ev.key()==self.shortCut_osd and self.showMode=='normal'):
			self.displayMenu_osdAction_()
		elif(ev.key()==self.shortCut_editor):
			self.openLrcEditorAction_()
		elif(ev.key()==self.shortCut_fastbar):
			if(self.toolMenuBar.isHidden()):
				self.toolMenuBar.show()
			else:
				self.toolMenuBar.hide()
		elif(ev.key()==self.shortCut_refresh):
			self.otherFunctionsMenu_reloadAction_()

	
	def closeEvent(self,ev):
		if(self.enableTrayIcon=='no'):
			self.beforeClosed()
			ev.accept()
		else:
			ev.ignore()
			self.hide()
	
	def beforeClosed(self):
		point=self.pos()
		x=point.x()
		y=point.y()
		if(self.topIsChecked):
			r='yes'
		else:
			r='no'
		self.configFile.set('option','lastposition','%s,%s' %(str(x),str(y)))
		self.configFile.set('option','lastshowmode',self.showMode)
		self.configFile.set('option','lastistop',r)
		self.configFile.set('option', 'scrolltype', self.scrollType)
		#self.configFileset('option','transeffect',self.transEffect)
		if(self.rememberOpacity=='yes' and self.transparency=='yes'):
			self.configFile.set('option','opacity',str(self.opacity))
		self.configFile.write(open('%s/.lrcShow-X/lrcShow-X.conf' %self.homePath, 'w'))
		try:
			os.remove('%s/.lrcShow-X/lrcShow-X.lock' %self.homePath)
		except:
			pass

	def quitWidnow(self):
		self.beforeClosed()
		sys.exit()
	
	def mouseReleaseEvent(self,ev):# disable this event
		pass
	
	def wheelEvent(self,ev):# disable this event
		if(self.transparency=='yes' and self.opacity<=10 and self.opacity>=1):
			self.opacity=self.opacity+ev.delta()/120
			if(self.opacity>10):
				self.opacity=10
			elif(self.opacity<1):
				self.opacity=1
			self.setWindowOpacity(self.opacity/10.0)
	
	def dragMoveEvent(self,ev):# disable this event
		pass
	
	def mousePressEvent(self,ev):# to get the coordinates for draging and moving the window
		self.xPos=ev.x()
		self.yPos=ev.y()

	def mouseMoveEvent(self,ev):# draging and moving the window, but in fullscreen display mode, the mouseTracking is True and this event is used to auto hide cursor
		if(self.showMode=='fullscreen'):
			self.currentCursorPos=ev.pos()
			if(self.viewport().cursor().shape() != Qt.ArrowCursor):
				self.viewport().setCursor(QCursor(Qt.ArrowCursor))
				self.hideMouseTimer.start(2000)
		else:
			if(ev.buttons()==Qt.LeftButton):
				a=ev.x()-self.xPos
				b=ev.y()-self.yPos
				self.move(self.x()+a,self.y()+b)
	
	def dragEnterEvent(self, ev):
		urls = ev.mimeData().urls()
		tmpName = str(urls[0].toLocalFile().toLocal8Bit())
		if(tmpName):
			self.dropFromLocal = True
		else:
			tmpName = str(urls[0].toString())
			self.dropFromLocal = False
		if(len(urls) == 1 and tmpName[-4:] == '.lrc' and self.amarokStatus != 'stop'):
			ev.acceptProposedAction()
		else:
			pass
	
	def dropEvent(self, ev):
		if(self.dropFromLocal):
			filename = str(ev.mimeData().urls()[0].toLocalFile().toLocal8Bit())
			self.fileName = filename
			file=open(self.fileName)
			lf=file.read()
			file.close()
			if lf.strip() == "":
				self.showInfo('<p align="center">'+_('Welcome to lrcShow-X')+'</p>')
			else:
				self.initEvent(lf, False, False, False)
		else:
			filename = str(ev.mimeData().urls()[0].toString())
			self.showInfo('<p align="center">'+_('Getting the lrc from internet...')+'</p>')
			self.downAfterChoose = downAfterChoose(self, filename, self.proxy, None)
			self.downAfterChoose.start()
	
	#def paintEvent(self, ev):
		#QTextBrowser.paintEvent(self, ev)
	
	def checkHideMouse(self):# this function is used to check if the cursor need to hide when a QTimer object's timeout signal is emit
		if(self.lastCursorPos==self.currentCursorPos):
			self.viewport().setCursor(QCursor(Qt.BlankCursor))
			if(self.hideMouseTimer.isActive()):
				self.hideMouseTimer.stop()
		else:
			self.lastCursorPos=self.currentCursorPos
